--[[
LibspellName2SID (deprecated)	/	LibSpellName2SID
V.10000:	2009 originally by Twobits[1], as part of ReadySpells[2]
			2010 edited by benots4[3]
			2017 published as an addon of its own by aallkkaa[4]
V.10001 - 10111:	2017-2020 WoW 7.3.x to 8.x versions by aallkkaa [4]
[1]	https://www.wowinterface.com/forums/member.php?userid=139157
	https://www.curseforge.com/members/twobits
[2]	https://www.curseforge.com/wow/addons/readyspells (Twobits' 3.x version: 
		2009)
[3]	https://www.wowinterface.com/forums/member.php?action=getinfo&userid=201937
[4]  https://www.wowinterface.com/forums/member.php?u=335646
]]--
----------------------------------------------------------------
-- LEGAL NOTICE (ABBREVIATED) -- --
-----------------------------------
--[[
Copyright (C) 2017-2020 aallkkaa <aallkkaa@gmx.com> [*], benots4
[*] This e-mail adress is provided for legal purposes only. For all other purposes (usage help, bug
reports, suggestions, etc) please use the project's page hosted on the WoWInterface website, at:
https://www.wowinterface.com/downloads/info24509-LibSpellName2SID.html

This software is licensed to you under the terms of an MIT license. A file named LICENSE.txt, which
 should have been included with your copy of this software, describes the licensing terms.
]]--
----------------------------------------------------------------
-- -- -- API -- -- --
----------------------
--[[
-- ENABLE IN YOUR ADDON --
local LibSpellName2SID = LibStub("LibSpellName2SID-1.1"):NewInstance(AddonName (STRING))

-- REMOVE FROM YOUR ADDON --
LibSpellName2SID:RemoveInstance(AddonName (STRING), DontErrorOnInexistentInstanceName (BOOLEAN))

-- USABLE METATABLES AND FUNCTIONS --
LibSpellName2SID.clients[AddonName].SID["EnglishSpellName"] -- Spell ID of English Spell Name 
	(STRING)
LibSpellName2SID.clients[AddonName].LSN["EnglishSpellName"] -- Localized Spell Name of English Spell
	Name (STRING)
LibSpellName2SID.SetFaction(faction (STRING), AddonName (STRING)) -- Set the faction to look up
	spells for (when applicable)

-- (OPTIONAL, BUT RECOMMENDED) LOCAL ALIAS --
local SID = LibSpellName2SID.clients[AddonName].SID	-- Useage: SID["EnglishSpellName"]
local LSN = LibSpellName2SID.clients[AddonName].LSN	-- Useage: LSN["EnglishSpellName"]
]]--
----------------------------------------------------------------


-- Initialization --
--------------------

-- Library's version values --
local LibSpellName2SID_MAJOR = "LibSpellName2SID-1.1";
local LibSpellName2SID_MINOR = 10111;

-- DataSource -- 
-- gameBuild = 33115 (Live/PTR 8.3.0)
-- clientLocale = enUS

-- Register with LibStub --
assert(LibStub, LibSpellName2SID_MAJOR.. "-".. LibSpellName2SID_MINOR.." requires LibStub.");
local oldLibSN2SID, oldMinor = LibStub:NewLibrary(LibSpellName2SID_MAJOR, LibSpellName2SID_MINOR);
if oldLibSN2SID == nil then	-- newer or same version of the lib is already present
	return;	-- Nothing needs to be done
else		-- no old lib or upgrade is needed
	if oldMinor and (oldMinor < LibSpellName2SID_MINOR) then -- old library object, upgrade needed
		LibSN2SID = oldLibSN2SID;
		if oldLibSN2SID.libFrame then	-- Reuse old lib's frame if available
			oldLibSN2SID.libFrame:UnregisterAllEvents();
			LibSN2SID.libFrame = oldLibSN2SID.libFrame;
		else
			LibSN2SID.libFrame = CreateFrame("Frame");
		end
	else	-- no old lib, return from LibStub:NewLibrary is an empty table
		LibSN2SID = oldLibSN2SID;
		LibSN2SID.libFrame = CreateFrame("Frame");
	end
end


-- Set the library database contents --
---------------------------------------

LibSN2SID.minor = LibSpellName2SID_MINOR;

if LibSN2SID.DB then	-- Clear old version's contents, if applicable
	wipe(LibSN2SID.DB); 
end

LibSN2SID.DB = {
	["DEATHKNIGHT"] = {
		["Frost_Talents"] = {
			["Wraith Walk"] = 212552,
			["Blinding Sleet"] = 207167,
			["Frostscythe"] = 207230,
			["Death Pact"] = 48743,
			["Horn of Winter"] = 57330,
			["Asphyxiate"] = 108194,
			["Breath of Sindragosa"] = 152279,
			["Frostwyrm's Fury"] = 279302,
			["Glacial Advance"] = 194913,
		},
		["Unholy"] = {
			["Scourge Strike"] = 55090,
			["Death and Decay"] = 43265,
			["Raise Dead"] = 46584,
			["Mind Freeze"] = 47528,
			["Runeforging"] = 53428,
			["Festering Strike"] = 85948,
			["Chains of Ice"] = 45524,
			["Army of the Dead"] = 42650,
			["Death Strike"] = 49998,
			["Raise Ally"] = 61999,
			["Corpse Exploder"] = 127344,
			["Dark Transformation"] = 63560,
			["Death Gate"] = 50977,
			["Death's Advance"] = 48265,
			["Dark Command"] = 56222,
			["Anti-Magic Shell"] = 48707,
			["Outbreak"] = 77575,
			["Death Coil"] = 47541,
			["Path of Frost"] = 3714,
			["Apocalypse"] = 275699,
			["Control Undead"] = 111673,
			["Icebound Fortitude"] = 48792,
			["Death Grip"] = 49576,
		},
		["Blood"] = {
			["Death and Decay"] = 43265,
			["Mind Freeze"] = 47528,
			["Runeforging"] = 53428,
			["Marrowrend"] = 195182,
			["Dancing Rune Weapon"] = 49028,
			["Gorefiend's Grasp"] = 108199,
			["Icebound Fortitude"] = 48792,
			["Heart Strike"] = 206930,
			["Death Strike"] = 49998,
			["Raise Ally"] = 61999,
			["Corpse Exploder"] = 127344,
			["Death Gate"] = 50977,
			["Death Grip"] = 49576,
			["Blood Boil"] = 50842,
			["Anti-Magic Shell"] = 48707,
			["Death's Advance"] = 48265,
			["Control Undead"] = 111673,
			["Path of Frost"] = 3714,
			["Asphyxiate"] = 221562,
			["Vampiric Blood"] = 55233,
			["Death's Caress"] = 195292,
			["Dark Command"] = 56222,
		},
		["Pets"] = {
			["Ghoul"] = {
				["Gnaw"] = 47481,
				["Claw"] = 47468,
				["Huddle"] = 47484,
				["Leap"] = 47482,
			},
		},
		["Frost"] = {
			["Pillar of Frost"] = 51271,
			["Mind Freeze"] = 47528,
			["Runeforging"] = 53428,
			["Chains of Ice"] = 45524,
			["Death Strike"] = 49998,
			["Raise Ally"] = 61999,
			["Corpse Exploder"] = 127344,
			["Howling Blast"] = 49184,
			["Death Grip"] = 49576,
			["Death Gate"] = 50977,
			["Obliterate"] = 49020,
			["Dark Command"] = 56222,
			["Anti-Magic Shell"] = 48707,
			["Frost Strike"] = 49143,
			["Control Undead"] = 111673,
			["Path of Frost"] = 3714,
			["Remorseless Winter"] = 196770,
			["Icebound Fortitude"] = 48792,
			["Empower Rune Weapon"] = 47568,
			["Death's Advance"] = 48265,
		},
		["Blood_Talents"] = {
			["Tombstone"] = 219809,
			["Wraith Walk"] = 212552,
			["Rune Tap"] = 194679,
			["Blooddrinker"] = 206931,
			["Bonestorm"] = 194844,
			["Rune Strike"] = 210764,
			["Consumption"] = 274156,
			["Mark of Blood"] = 206940,
		},
		["Unholy_Talents"] = {
			["Summon Gargoyle"] = 49206,
			["Wraith Walk"] = 212552,
			["Clawing Shadows"] = 207311,
			["Epidemic"] = 207317,
			["Death Pact"] = 48743,
			["Unholy Blight"] = 115989,
			["Asphyxiate"] = 108194,
			["Defile"] = 152280,
			["Soul Reaper"] = 130736,
			["Unholy Frenzy"] = 207289,
		},
		["Blood_PVPTalents"] = {
			["Strangulate"] = 47476,
			["Necrotic Strike"] = 223829,
			["Transfusion"] = 288977,
			["Anti-Magic Zone"] = 51052,
			["Blood for Blood"] = 233411,
			["Raise Abomination"] = 288853,
			["Chill Streak"] = 305392,
			["Murderous Intent"] = 207018,
			["Gladiator's Medallion"] = 208683,
			["Death Chain"] = 203173,
			["Lichborne"] = 287081,
			["Reanimation"] = 210128,
			["Dark Simulacrum"] = 77606,
		},
		["Frost_PVPTalents"] = {
			["Strangulate"] = 47476,
			["Necrotic Strike"] = 223829,
			["Transfusion"] = 288977,
			["Anti-Magic Zone"] = 51052,
			["Blood for Blood"] = 233411,
			["Raise Abomination"] = 288853,
			["Chill Streak"] = 305392,
			["Murderous Intent"] = 207018,
			["Gladiator's Medallion"] = 208683,
			["Death Chain"] = 203173,
			["Lichborne"] = 287081,
			["Reanimation"] = 210128,
			["Dark Simulacrum"] = 77606,
		},
		["Unholy_PVPTalents"] = {
			["Strangulate"] = 47476,
			["Necrotic Strike"] = 223829,
			["Transfusion"] = 288977,
			["Anti-Magic Zone"] = 51052,
			["Blood for Blood"] = 233411,
			["Raise Abomination"] = 288853,
			["Chill Streak"] = 305392,
			["Murderous Intent"] = 207018,
			["Gladiator's Medallion"] = 208683,
			["Death Chain"] = 203173,
			["Lichborne"] = 287081,
			["Reanimation"] = 210128,
			["Dark Simulacrum"] = 77606,
		},
	},
	["WARRIOR"] = {
		["Protection"] = {
			["Taunt"] = 355,
			["Intimidating Shout"] = 5246,
			["Avatar"] = 107574,
			["Thunder Clap"] = 6343,
			["Shield Block"] = 2565,
			["Charge"] = 100,
			["Shockwave"] = 46968,
			["Devastate"] = 20243,
			["Shield Slam"] = 23922,
			["Berserker Rage"] = 18499,
			["Rallying Cry"] = 97462,
			["Demoralizing Shout"] = 1160,
			["Ignore Pain"] = 190456,
			["Spell Reflection"] = 23920,
			["Intercept"] = 198304,
			["Last Stand"] = 12975,
			["Battle Shout"] = 6673,
			["Revenge"] = 6572,
			["Pummel"] = 6552,
			["Heroic Leap"] = 6544,
			["Victory Rush"] = 34428,
			["Heroic Throw"] = 57755,
			["Shield Wall"] = 871,
		},
		["Arms_Talents"] = {
			["Warbreaker"] = 262161,
			["Rend"] = 772,
			["Skullsplitter"] = 260643,
			["Defensive Stance"] = 197690,
			["Deadly Calm"] = 262228,
			["Impending Victory"] = 202168,
			["Avatar"] = 107574,
			["Ravager"] = 152277,
			["Cleave"] = 845,
			["Storm Bolt"] = 107570,
		},
		["Fury"] = {
			["Battle Shout"] = 6673,
			["Charge"] = 100,
			["Execute"] = 5308,
			["Whirlwind"] = 190411,
			["Rampage"] = 184367,
			["Piercing Howl"] = 12323,
			["Bloodthirst"] = 23881,
			["Raging Blow"] = 85288,
			["Recklessness"] = 1719,
			["Rallying Cry"] = 97462,
			["Intimidating Shout"] = 5246,
			["Berserker Rage"] = 18499,
			["Pummel"] = 6552,
			["Enraged Regeneration"] = 184364,
			["Heroic Leap"] = 6544,
			["Victory Rush"] = 34428,
			["Heroic Throw"] = 57755,
			["Taunt"] = 355,
		},
		["Fury_Talents"] = {
			["Impending Victory"] = 202168,
			["Storm Bolt"] = 107570,
			["Bladestorm"] = 46924,
			["Dragon Roar"] = 118000,
			["Siegebreaker"] = 280772,
			["Furious Slash"] = 100130,
		},
		["Protection_PVPTalents"] = {
			["Spell Reflection"] = 216890,
			["Disarm"] = 236077,
			["Gladiator's Medallion"] = 208683,
			["Death Wish"] = 199261,
			["War Banner"] = 236320,
			["Sharpen Blade"] = 198817,
			["Duel"] = 236273,
		},
		["Fury_PVPTalents"] = {
			["Spell Reflection"] = 216890,
			["Disarm"] = 236077,
			["Gladiator's Medallion"] = 208683,
			["Death Wish"] = 199261,
			["War Banner"] = 236320,
			["Sharpen Blade"] = 198817,
			["Duel"] = 236273,
		},
		["Arms_PVPTalents"] = {
			["Spell Reflection"] = 216890,
			["Disarm"] = 236077,
			["Gladiator's Medallion"] = 208683,
			["Death Wish"] = 199261,
			["War Banner"] = 236320,
			["Sharpen Blade"] = 198817,
			["Duel"] = 236273,
		},
		["Arms"] = {
			["Battle Shout"] = 6673,
			["Charge"] = 100,
			["Slam"] = 1464,
			["Whirlwind"] = 1680,
			["Sweeping Strikes"] = 260708,
			["Berserker Rage"] = 18499,
			["Overpower"] = 7384,
			["Hamstring"] = 1715,
			["Intimidating Shout"] = 5246,
			["Rallying Cry"] = 97462,
			["Colossus Smash"] = 167105,
			["Taunt"] = 355,
			["Victory Rush"] = 34428,
			["Bladestorm"] = 227847,
			["Execute"] = 163201,
			["Pummel"] = 6552,
			["Heroic Leap"] = 6544,
			["Die by the Sword"] = 118038,
			["Heroic Throw"] = 57755,
			["Mortal Strike"] = 12294,
		},
		["Protection_Talents"] = {
			["Ravager"] = 228920,
			["Dragon Roar"] = 118000,
			["Impending Victory"] = 202168,
			["Storm Bolt"] = 107570,
		},
	},
	["General"] = {
		["AzeriteEssences"] = {
			["Vision of Perfection(Rank 3)"] = 299370,
			["Worldvein Resonance"] = 295186,
			["Suppressing Pulse(Rank 3)"] = 300010,
			["Overcharge Mana"] = 296072,
			["Azeroth's Undying Gift(Rank 2)"] = 298080,
			["Blood of the Enemy"] = 297108,
			["Refreshment(Rank 2)"] = 299932,
			["Vision of Perfection(Rank 1)"] = 296325,
			["Vision of Perfection(Rank 4)"] = 299370,
			["Conflict(Rank 1)"] = 303823,
			["Standstill(Rank 2)"] = 299882,
			["Vitality Conduit(Rank 1)"] = 296230,
			["Suppressing Pulse(Rank 1)"] = 293031,
			["Suppressing Pulse(Rank 4)"] = 300010,
			["Purifying Blast(Rank 1)"] = 295337,
			["Anima of Death"] = 294926,
			["Guardian of Azeroth(Rank 2)"] = 299355,
			["Focused Azerite Beam(Rank 3)"] = 299338,
			["Purifying Blast(Rank 4)"] = 299347,
			["Worldvein Resonance(Rank 4)"] = 299334,
			["Concentrated Flame(Rank 1)"] = 295373,
			["The Unbound Force(Rank 1)"] = 298452,
			["Life-Binder's Invocation(Rank 3)"] = 299944,
			["Vitality Conduit(Rank 4)"] = 299959,
			["Aegis of the Deep"] = 298168,
			["Overcharge Mana(Rank 2)"] = 299875,
			["Blood of the Enemy(Rank 2)"] = 298273,
			["Anima of Death(Rank 2)"] = 300002,
			["Concentrated Flame(Rank 4)"] = 299353,
			["Vision of Perfection"] = 296325,
			["Empowered Null Barrier(Rank 3)"] = 300016,
			["Ripple in Space(Rank 2)"] = 302982,
			["Guardian of Azeroth(Rank 3)"] = 299358,
			["Aegis of the Deep(Rank 1)"] = 298168,
			["Ripple in Space"] = 302731,
			["Empowered Null Barrier(Rank 4)"] = 300016,
			["Azeroth's Undying Gift(Rank 1)"] = 293019,
			["Overcharge Mana(Rank 1)"] = 296072,
			["Conflict"] = 303823,
			["Life-Binder's Invocation(Rank 4)"] = 299944,
			["Conflict(Rank 2)"] = 304088,
			["Guardian of Azeroth"] = 295840,
			["Concentrated Flame"] = 296208,
			["Worldvein Resonance(Rank 2)"] = 298628,
			["Empowered Null Barrier"] = 295746,
			["Life-Binder's Invocation"] = 293032,
			["Memory of Lucid Dreams(Rank 2)"] = 299372,
			["Memory of Lucid Dreams(Rank 3)"] = 299374,
			["Refreshment(Rank 4)"] = 299933,
			["Conflict(Rank 3)"] = 304121,
			["Focused Azerite Beam(Rank 1)"] = 295258,
			["Focused Azerite Beam"] = 295258,
			["Life-Binder's Invocation(Rank 1)"] = 293032,
			["The Unbound Force(Rank 3)"] = 299378,
			["Vitality Conduit(Rank 3)"] = 299959,
			["Concentrated Flame(Rank 2)"] = 299349,
			["Empowered Null Barrier(Rank 1)"] = 295746,
			["Overcharge Mana(Rank 4)"] = 299876,
			["Suppressing Pulse"] = 293031,
			["Heart Essence"] = 296208,
			["Azeroth's Undying Gift(Rank 4)"] = 298081,
			["Conflict(Rank 4)"] = 304121,
			["Worldvein Resonance(Rank 1)"] = 295186,
			["Memory of Lucid Dreams"] = 298357,
			["Concentrated Flame(Rank 3)"] = 299353,
			["The Unbound Force(Rank 4)"] = 299378,
			["The Unbound Force(Rank 2)"] = 299376,
			["Blood of the Enemy(Rank 1)"] = 297108,
			["Vitality Conduit"] = 296230,
			["Vitality Conduit(Rank 2)"] = 299958,
			["Ripple in Space(Rank 1)"] = 302731,
			["The Unbound Force"] = 298452,
			["Guardian of Azeroth(Rank 4)"] = 299358,
			["Standstill(Rank 4)"] = 299883,
			["Empowered Null Barrier(Rank 2)"] = 300015,
			["Anima of Death(Rank 4)"] = 300003,
			["Purifying Blast(Rank 2)"] = 299345,
			["Standstill"] = 296094,
			["Refreshment(Rank 3)"] = 299933,
			["Azeroth's Undying Gift(Rank 3)"] = 298081,
			["Blood of the Enemy(Rank 3)"] = 298277,
			["Focused Azerite Beam(Rank 2)"] = 299336,
			["Aegis of the Deep(Rank 2)"] = 299273,
			["Ripple in Space(Rank 3)"] = 302983,
			["Memory of Lucid Dreams(Rank 1)"] = 298357,
			["Purifying Blast"] = 295337,
			["Memory of Lucid Dreams(Rank 4)"] = 299374,
			["Suppressing Pulse(Rank 2)"] = 300009,
			["Standstill(Rank 3)"] = 299883,
			["Anima of Death(Rank 3)"] = 300003,
			["Refreshment"] = 296197,
			["Blood of the Enemy(Rank 4)"] = 298277,
			["Anima of Death(Rank 1)"] = 294926,
			["Overcharge Mana(Rank 3)"] = 299876,
			["Worldvein Resonance(Rank 3)"] = 299334,
			["Guardian of Azeroth(Rank 1)"] = 295840,
			["Life-Binder's Invocation(Rank 2)"] = 299943,
			["Aegis of the Deep(Rank 3)"] = 299275,
			["Focused Azerite Beam(Rank 4)"] = 299338,
			["Aegis of the Deep(Rank 4)"] = 299275,
			["Vision of Perfection(Rank 2)"] = 299368,
			["Purifying Blast(Rank 3)"] = 299347,
			["Refreshment(Rank 1)"] = 296197,
			["Ripple in Space(Rank 4)"] = 302983,
			["Azeroth's Undying Gift"] = 293019,
			["Standstill(Rank 1)"] = 296094,
		},
		["Racials"] = {
			["NightElf"] = {
				["Shadowmeld"] = 58984,
			},
			["Orc"] = {
				["Blood Fury"] = 20572,
			},
			["VoidElf"] = {
				["Spatial Rift"] = 256948,
				["Spatial Rift(Step 1)"] = 256948,
				["Spatial Rift(Step 2)"] = 257040,
			},
			["Pandaren"] = {
				["Quaking Palm"] = 107079,
			},
			["Draenei"] = {
				["Gift of the Naaru"] = 59547,
			},
			["Worgen"] = {
				["Running Wild"] = 87840,
				["Two Forms"] = 68996,
				["Darkflight"] = 68992,
			},
			["Scourge"] = {
				["Cannibalize"] = 20577,
				["Will of the Forsaken"] = 7744,
			},
			["KulTiran"] = {
				["Haymaker"] = 287712,
			},
			["Gnome"] = {
				["Escape Artist"] = 20589,
			},
			["Dwarf"] = {
				["Stoneform"] = 20594,
			},
			["BloodElf"] = {
				["Arcane Torrent"] = 129597,
			},
			["LightforgedDraenei"] = {
				["Forge of Light"] = 259930,
				["Light's Judgment"] = 255647,
			},
			["Tauren"] = {
				["War Stomp"] = 20549,
			},
			["Troll"] = {
				["Berserking"] = 26297,
			},
			["Human"] = {
				["Every Man for Himself"] = 59752,
			},
			["DarkIronDwarf"] = {
				["Fireblood"] = 265221,
				["Mole Machine"] = 265225,
			},
			["Goblin"] = {
				["Rocket Barrage"] = 69041,
				["Rocket Jump"] = 69070,
				["Pack Hobgoblin"] = 69046,
			},
			["MagharOrc"] = {
				["Ancestral Call"] = 274738,
			},
			["Nightborne"] = {
				["Arcane Pulse"] = 260364,
				["Cantrips"] = 255661,
			},
			["HighmountainTauren"] = {
				["Bull Rush"] = 255654,
			},
			["Mechagnome"] = {
				["Skeleton Pinkie"] = 312890,
				["Hyper Organic Light Originator"] = 312924,
			},
			["Vulpera"] = {
				["Return to Camp"] = 312372,
				["Bag of Tricks"] = 312411,
				["Make Camp"] = 312370,
				["Rummage Your Bag"] = 312425,
			},
			["ZandalariTroll"] = {
				["Embrace of the Loa"] = 292752,
				["Regeneratin'"] = 291944,
				["Pterrordax Swoop"] = 281954,
			},
		},
		["ZoneAbilities"] = {
			["Telaari Talbuk"] = 165803,
			["Combat Ally"] = 211390,
			["Summon Mechashredder 5000"] = 164050,
			["Home Away from Home"] = 168487,
			["Fel Heart Bond"] = 248011,
			["Garrison Ability"] = 161691,
			["Guardian Orb"] = 161767,
			["Vindicaar Matrix Crystal"] = 251463,
			["Smuggling Run!"] = 170108,
			["Summon Lightforged Warframe"] = 250436,
			["Champion's Honor"] = 164221,
			["Telaari Siege Engine"] = 160240,
			["Frostwolf War Wolf"] = 164222,
			["Artillery Strike"] = 162075,
			["Logging"] = 167895,
			["Shroud of Arcane Echoes"] = 248779,
			["Call to Arms"] = 161676,
			["Light's Judgment"] = 247427,
		},
		["GuildPerks"] = {
			["Mobile Banking"] = 83958,
		},
		["Others"] = {
			["Revive Battle Pets"] = 125439,
			["Auto Shot"] = 75,
			["Wartime Ability"] = 264739,
			["Shoot"] = 5019,
			["Herbalism Skills"] = 193290,
			["Sanity Restoration Orb"] = 314955,
			["Honorable Medallion"] = 195710,
			["Cooking Fire"] = 818,
			["Auto Attack"] = 6603,
		},
	},
	["SHAMAN"] = {
		["Restoration_PVPTalents"] = {
			["Counterstrike Totem"] = 204331,
			["Thundercharge"] = 204366,
			["Spirit Link"] = 204293,
			["Lightning Lasso"] = 305483,
			["Skyfury Totem"] = 204330,
			["Ethereal Form"] = 210918,
			["Gladiator's Medallion"] = 208683,
			["Grounding Totem"] = 204336,
		},
		["Elemental"] = {
			["Astral Shift"] = 108271,
			["Tremor Totem"] = 8143,
			["Fire Elemental"] = 198067,
			["Healing Surge"] = 8004,
			["Earth Elemental"] = 198103,
			["Heroism"] = 32182,
			["Ghost Wolf"] = 2645,
			["Flame Shock"] = 188389,
			["Heroism(Shamanism)"] = 204362,
			["Earthbind Totem"] = 2484,
			["Earthquake"] = 61882,
			["Thunderstorm"] = 51490,
			["Ancestral Spirit"] = 2008,
			["Water Walking"] = 546,
			["Bloodlust(Shamanism)"] = 204361,
			["Far Sight"] = 6196,
			["Hex"] = 51514,
			["Purge"] = 370,
			["Lava Burst"] = 51505,
			["Heroism(NoShamanism)"] = 32182,
			["Hex Variants"] = 106,
			["Frost Shock"] = 196840,
			["Cleanse Spirit"] = 51886,
			["Bloodlust"] = 2825,
			["Lightning Bolt"] = 188196,
			["Bloodlust(NoShamanism)"] = 2825,
			["Wind Shear"] = 57994,
			["Astral Recall"] = 556,
			["Capacitor Totem"] = 192058,
			["Hex(Frog)"] = 51514,
			["Chain Lightning"] = 188443,
			["Earth Shock"] = 8042,
		},
		["Flyouts"] = {
			["Hex Variants"] = {
				["Hex(Living Honey)"] = 309328,
				["Hex(Wicker Mongrel)"] = 277784,
				["Hex(Skeletal Hatchling)"] = 269352,
				["Hex(Spider)"] = 211004,
				["Hex(Compy)"] = 210873,
				["Hex(Zandalari Tendonripper)"] = 277778,
				["Hex(Cockroach)"] = 211015,
				["Hex(Snake)"] = 211010,
			},
		},
		["Enhancement"] = {
			["Healing Surge"] = 188070,
			["Astral Shift"] = 108271,
			["Feral Spirit"] = 51533,
			["Rockbiter"] = 193786,
			["Crash Lightning"] = 187874,
			["Lava Lash"] = 60103,
			["Ghost Wolf"] = 2645,
			["Hex(Frog)"] = 51514,
			["Heroism(Shamanism)"] = 204362,
			["Ancestral Spirit"] = 2008,
			["Flametongue"] = 193796,
			["Capacitor Totem"] = 192058,
			["Heroism"] = 32182,
			["Water Walking"] = 546,
			["Bloodlust(Shamanism)"] = 204361,
			["Earthbind Totem"] = 2484,
			["Hex"] = 51514,
			["Stormstrike"] = 17364,
			["Far Sight"] = 6196,
			["Heroism(NoShamanism)"] = 32182,
			["Hex Variants"] = 106,
			["Cleanse Spirit"] = 51886,
			["Lightning Bolt"] = 187837,
			["Bloodlust"] = 2825,
			["Purge"] = 370,
			["Bloodlust(NoShamanism)"] = 2825,
			["Wind Shear"] = 57994,
			["Astral Recall"] = 556,
			["Frostbrand"] = 196834,
			["Spirit Walk"] = 58875,
			["Earth Elemental"] = 198103,
			["Tremor Totem"] = 8143,
		},
		["Enhancement_PVPTalents"] = {
			["Counterstrike Totem"] = 204331,
			["Thundercharge"] = 204366,
			["Spirit Link"] = 204293,
			["Lightning Lasso"] = 305483,
			["Skyfury Totem"] = 204330,
			["Ethereal Form"] = 210918,
			["Gladiator's Medallion"] = 208683,
			["Grounding Totem"] = 204336,
		},
		["Pets"] = {
			["Storm Elemental"] = {
				["Call Lightning"] = 157348,
				["Eye of the Storm"] = 157375,
				["Wind Gust"] = 157331,
			},
			["Fire Elemental"] = {
				["Meteor"] = 117588,
				["Immolate"] = 118297,
				["Fire Blast"] = 57984,
			},
			["Earth Elemental"] = {
				["Angered Earth"] = 36213,
				["Pulverize"] = 118345,
				["Harden Skin"] = 118337,
			},
		},
		["Elemental_PVPTalents"] = {
			["Counterstrike Totem"] = 204331,
			["Thundercharge"] = 204366,
			["Spirit Link"] = 204293,
			["Lightning Lasso"] = 305483,
			["Skyfury Totem"] = 204330,
			["Ethereal Form"] = 210918,
			["Gladiator's Medallion"] = 208683,
			["Grounding Totem"] = 204336,
		},
		["Elemental_Talents"] = {
			["Liquid Magma Totem"] = 192222,
			["Totem Mastery"] = 210643,
			["Icefury"] = 210714,
			["Wind Rush Totem"] = 192077,
			["Earth Shield"] = 974,
			["Storm Elemental"] = 192249,
			["Ascendance"] = 114050,
			["Elemental Blast"] = 117014,
			["Ancestral Guidance"] = 108281,
			["Stormkeeper"] = 191634,
		},
		["Restoration_Talents"] = {
			["Earthen Wall Totem"] = 198838,
			["Wind Rush Totem"] = 192077,
			["Ancestral Protection Totem"] = 207399,
			["Earth Shield"] = 974,
			["Unleash Life"] = 73685,
			["Wellspring"] = 197995,
			["Cloudburst Totem"] = 157153,
			["Ascendance"] = 114052,
			["Downpour"] = 207778,
			["Earthgrab Totem"] = 51485,
		},
		["Restoration"] = {
			["Healing Wave"] = 77472,
			["Healing Tide Totem"] = 108280,
			["Ghost Wolf"] = 2645,
			["Flame Shock"] = 188838,
			["Spiritwalker's Grace"] = 79206,
			["Purify Spirit"] = 77130,
			["Ancestral Spirit"] = 2008,
			["Water Walking"] = 546,
			["Bloodlust(Shamanism)"] = 204361,
			["Hex Variants"] = 106,
			["Healing Rain"] = 73920,
			["Astral Recall"] = 556,
			["Chain Lightning"] = 421,
			["Lava Burst"] = 51505,
			["Ancestral Vision"] = 212048,
			["Hex(Frog)"] = 51514,
			["Heroism(Shamanism)"] = 204362,
			["Earth Elemental"] = 198103,
			["Heroism"] = 32182,
			["Earthbind Totem"] = 2484,
			["Hex"] = 51514,
			["Chain Heal"] = 1064,
			["Purge"] = 370,
			["Spirit Link Totem"] = 98008,
			["Healing Surge"] = 8004,
			["Heroism(NoShamanism)"] = 32182,
			["Lightning Bolt"] = 403,
			["Bloodlust"] = 2825,
			["Riptide"] = 61295,
			["Bloodlust(NoShamanism)"] = 2825,
			["Wind Shear"] = 57994,
			["Capacitor Totem"] = 192058,
			["Far Sight"] = 6196,
			["Healing Stream Totem"] = 5394,
			["Tremor Totem"] = 8143,
			["Astral Shift"] = 108271,
		},
		["Enhancement_Talents"] = {
			["Fury of Air"] = 197211,
			["Wind Rush Totem"] = 192077,
			["Earth Shield"] = 974,
			["Lightning Shield"] = 192106,
			["Earthen Spike"] = 188089,
			["Sundering"] = 197214,
			["Ascendance"] = 114051,
			["Feral Lunge"] = 196884,
			["Totem Mastery"] = 262395,
		},
	},
	["MAGE"] = {
		["Fire_PVPTalents"] = {
			["Gladiator's Medallion"] = 208683,
			["Ice Form"] = 198144,
			["Temporal Shield"] = 198111,
		},
		["Frost_Talents"] = {
			["Ice Nova"] = 157997,
			["Ebonbolt"] = 257537,
			["Glacial Spike"] = 199786,
			["Mirror Image"] = 55342,
			["Rune of Power"] = 116011,
			["Ring of Frost"] = 113724,
			["Ice Floes"] = 108839,
			["Shimmer"] = 212653,
			["Comet Storm"] = 153595,
			["Ray of Frost"] = 205021,
		},
		["Flyouts"] = {
			["Portal"] = {
				["Portal: Exodar"] = 32266,
				["Portal: Stonard"] = 49361,
				["Portal: Undercity"] = 11418,
				["Portal: Vale of Eternal Blossoms(Horde)"] = 132626,
				["Portal: Vale of Eternal Blossoms(Alliance)"] = 132620,
				["Ancient Portal: Dalaran"] = 120146,
				["Portal: Stormwind"] = 10059,
				["Portal: Warspear"] = 176244,
				["Portal: Theramore"] = 49360,
				["Portal: Thunder Bluff"] = 11420,
				["Portal: Darnassus"] = 11419,
				["Portal: Silvermoon"] = 32267,
				["Portal: Tol Barad(Alliance)"] = 88345,
				["Portal: Orgrimmar"] = 11417,
				["Portal: Shattrath(Horde)"] = 35717,
				["Portal: Dazar'alor"] = 281402,
				["Portal: Tol Barad(Horde)"] = 88346,
				["Portal: Stormshield"] = 176246,
				["Portal: Shattrath(Alliance)"] = 33691,
				["Portal: Dalaran - Broken Isles"] = 224871,
				["Portal: Boralus"] = 281400,
				["Portal: Dalaran - Northrend"] = 53142,
				["Portal: Ironforge"] = 11416,
			},
			["Polymorph Variants"] = {
				["Polymorph(Peacock)"] = 161372,
				["Polymorph(Rabbit)"] = 61721,
				["Polymorph(Monkey)"] = 161354,
				["Polymorph(Direhorn)"] = 277787,
				["Polymorph(Porcupine)"] = 126819,
				["Polymorph(Polar Bear Cub)"] = 161353,
				["Polymorph(Turtle)"] = 28271,
				["Polymorph(Turkey)"] = 61780,
				["Polymorph(Bumblebee)"] = 277792,
				["Polymorph(Penguin)"] = 161355,
				["Polymorph(Serpent)"] = 61025,
				["Polymorph(Pig)"] = 28272,
				["Polymorph(Black Cat)"] = 61305,
			},
			["Teleport"] = {
				["Teleport: Dalaran - Northrend"] = 53140,
				["Teleport: Vale of Eternal Blossoms(Horde)"] = 132627,
				["Teleport: Stonard"] = 49358,
				["Teleport: Stormshield"] = 176248,
				["Teleport: Darnassus"] = 3565,
				["Teleport: Vale of Eternal Blossoms(Alliance)"] = 132621,
				["Teleport: Dalaran - Broken Isles"] = 224869,
				["Teleport: Boralus"] = 281403,
				["Teleport: Stormwind"] = 3561,
				["Teleport: Hall of the Guardian"] = 193759,
				["Teleport: Shattrath(Horde)"] = 35715,
				["Teleport: Dazar'alor"] = 281404,
				["Teleport: Tol Barad(Horde)"] = 88344,
				["Teleport: Shattrath(Alliance)"] = 33690,
				["Teleport: Tol Barad(Alliance)"] = 88342,
				["Teleport: Orgrimmar"] = 3567,
				["Teleport: Ironforge"] = 3562,
				["Teleport: Warspear"] = 176242,
				["Teleport: Theramore"] = 49359,
				["Teleport: Silvermoon"] = 32272,
				["Teleport: Undercity"] = 3563,
				["Ancient Teleport: Dalaran"] = 120145,
				["Teleport: Exodar"] = 32271,
				["Teleport: Thunder Bluff"] = 3566,
			},
		},
		["Arcane_Talents"] = {
			["Mirror Image"] = 55342,
			["Rune of Power"] = 116011,
			["Nether Tempest"] = 114923,
			["Charged Up"] = 205032,
			["Ring of Frost"] = 113724,
			["Arcane Orb"] = 153626,
			["Shimmer"] = 212653,
			["Arcane Familiar"] = 205022,
			["Supernova"] = 157980,
		},
		["Frost"] = {
			["Arcane Intellect"] = 1459,
			["Blizzard"] = 190356,
			["Frostbolt"] = 116,
			["Frozen Orb"] = 84714,
			["Polymorph"] = 118,
			["Cold Snap"] = 235219,
			["Remove Curse"] = 475,
			["Flurry"] = 44614,
			["Spellsteal"] = 30449,
			["Time Warp"] = 80353,
			["Conjure Refreshment"] = 190336,
			["Ice Barrier"] = 11426,
			["Portal"] = 11,
			["Teleport"] = 1,
			["Summon Water Elemental"] = 31687,
			["Frost Nova"] = 122,
			["Polymorph Variants"] = 92,
			["Icy Veins"] = 12472,
			["Slow Fall"] = 130,
			["Blink"] = 1953,
			["Ice Block"] = 45438,
			["Ice Lance"] = 108853,
			["Counterspell"] = 2139,
			["Polymorph(Sheep)"] = 118,
			["Cone of Cold"] = 120,
			["Invisibility"] = 66,
		},
		["Frost_PVPTalents"] = {
			["Gladiator's Medallion"] = 208683,
			["Ice Form"] = 198144,
			["Temporal Shield"] = 198111,
		},
		["Arcane"] = {
			["Arcane Blast"] = 30451,
			["Arcane Power"] = 12042,
			["Arcane Explosion"] = 1449,
			["Prismatic Barrier"] = 235450,
			["Polymorph"] = 118,
			["Presence of Mind"] = 205025,
			["Remove Curse"] = 475,
			["Slow"] = 31589,
			["Arcane Intellect"] = 1459,
			["Conjure Refreshment"] = 190336,
			["Time Warp"] = 80353,
			["Evocation"] = 12051,
			["Polymorph(Sheep)"] = 118,
			["Teleport"] = 1,
			["Frost Nova"] = 122,
			["Arcane Missiles"] = 5143,
			["Polymorph Variants"] = 92,
			["Slow Fall"] = 130,
			["Ice Block"] = 45438,
			["Blink"] = 1953,
			["Greater Invisibility"] = 110959,
			["Portal"] = 11,
			["Counterspell"] = 2139,
			["Arcane Barrage"] = 44425,
			["Spellsteal"] = 30449,
			["Displacement"] = 195676,
		},
		["Pets"] = {
			["Water Elemental"] = {
				["Freeze"] = 33395,
				["Waterbolt"] = 31707,
			},
		},
		["Fire"] = {
			["Fireball"] = 133,
			["Dragon's Breath"] = 31661,
			["Fire Blast"] = 108853,
			["Polymorph"] = 118,
			["Pyroblast"] = 11366,
			["Remove Curse"] = 475,
			["Scorch"] = 2948,
			["Flamestrike"] = 2120,
			["Conjure Refreshment"] = 190336,
			["Portal"] = 11,
			["Polymorph(Sheep)"] = 118,
			["Teleport"] = 1,
			["Blazing Barrier"] = 235313,
			["Combustion"] = 190319,
			["Polymorph Variants"] = 92,
			["Ice Block"] = 45438,
			["Counterspell"] = 2139,
			["Blink"] = 1953,
			["Slow Fall"] = 130,
			["Arcane Intellect"] = 1459,
			["Frost Nova"] = 122,
			["Spellsteal"] = 30449,
			["Time Warp"] = 80353,
			["Invisibility"] = 66,
		},
		["Fire_Talents"] = {
			["Phoenix Flames"] = 257541,
			["Ring of Frost"] = 113724,
			["Meteor"] = 153561,
			["Shimmer"] = 212653,
			["Mirror Image"] = 55342,
			["Rune of Power"] = 116011,
			["Blast Wave"] = 157981,
			["Living Bomb"] = 44457,
		},
		["Arcane_PVPTalents"] = {
			["Gladiator's Medallion"] = 208683,
			["Ice Form"] = 198144,
			["Temporal Shield"] = 198111,
		},
	},
	["PRIEST"] = {
		["Shadow"] = {
			["Purify Disease"] = 213634,
			["Resurrection"] = 2006,
			["Shackle Undead"] = 9484,
			["Shadow Word: Pain"] = 589,
			["Fade"] = 586,
			["Mind Vision"] = 2096,
			["Shadowform"] = 232698,
			["Silence"] = 15487,
			["Dispersion"] = 47585,
			["Mind Sear"] = 48045,
			["Mind Blast"] = 8092,
			["Vampiric Embrace"] = 15286,
			["Void Eruption"] = 228260,
			["Mind Flay"] = 15407,
			["Shadow Mend"] = 186263,
			["Mind Control"] = 605,
			["Power Word: Fortitude"] = 21562,
			["Psychic Scream"] = 8122,
			["Leap of Faith"] = 73325,
			["Power Word: Shield"] = 17,
			["Levitate"] = 1706,
			["Dispel Magic"] = 528,
			["Vampiric Touch"] = 34914,
			["Shadowfiend"] = 34433,
			["Mass Dispel"] = 32375,
		},
		["Shadow_PVPTalents"] = {
			["Dark Archangel"] = 197871,
			["Premonition"] = 305498,
			["Archangel"] = 197862,
			["Gladiator's Medallion"] = 208683,
		},
		["Holy_Talents"] = {
			["Circle of Healing"] = 204883,
			["Divine Star"] = 110744,
			["Shining Force"] = 204263,
			["Binding Heal"] = 32546,
			["Halo"] = 120517,
			["Holy Word: Salvation"] = 265202,
			["Apotheosis"] = 200183,
			["Angelic Feather"] = 121536,
		},
		["Holy_PVPTalents"] = {
			["Dark Archangel"] = 197871,
			["Premonition"] = 305498,
			["Archangel"] = 197862,
			["Gladiator's Medallion"] = 208683,
		},
		["Holy"] = {
			["Renew"] = 139,
			["Resurrection"] = 2006,
			["Shackle Undead"] = 9484,
			["Holy Nova"] = 132157,
			["Symbol of Hope"] = 64901,
			["Fade"] = 586,
			["Mind Vision"] = 2096,
			["Mass Dispel"] = 32375,
			["Levitate"] = 1706,
			["Holy Word: Serenity"] = 2050,
			["Purify"] = 527,
			["Smite"] = 585,
			["Desperate Prayer"] = 19236,
			["Holy Fire"] = 14914,
			["Prayer of Healing"] = 596,
			["Flash Heal"] = 2061,
			["Power Word: Fortitude"] = 21562,
			["Holy Word: Chastise"] = 88625,
			["Mass Resurrection"] = 212036,
			["Holy Word: Sanctify"] = 34861,
			["Psychic Scream"] = 8122,
			["Mind Control"] = 605,
			["Divine Hymn"] = 64843,
			["Guardian Spirit"] = 47788,
			["Dispel Magic"] = 528,
			["Heal"] = 2060,
			["Leap of Faith"] = 73325,
			["Prayer of Mending"] = 33076,
		},
		["Discipline_PVPTalents"] = {
			["Dark Archangel"] = 197871,
			["Premonition"] = 305498,
			["Archangel"] = 197862,
			["Gladiator's Medallion"] = 208683,
		},
		["Discipline"] = {
			["Power Word: Radiance"] = 194509,
			["Resurrection"] = 2006,
			["Shackle Undead"] = 9484,
			["Rapture"] = 47536,
			["Holy Nova"] = 132157,
			["Fade"] = 586,
			["Mind Vision"] = 2096,
			["Mass Dispel"] = 32375,
			["Shadow Word: Pain"] = 589,
			["Shadowfiend"] = 34433,
			["Desperate Prayer"] = 19236,
			["Power Word: Shield"] = 17,
			["Levitate"] = 1706,
			["Flash Heal"] = 2061,
			["Power Word: Fortitude"] = 21562,
			["Shadow Mend"] = 2061,
			["Mind Control"] = 605,
			["Penance"] = 47540,
			["Psychic Scream"] = 8122,
			["Leap of Faith"] = 73325,
			["Mass Resurrection"] = 212036,
			["Smite"] = 585,
			["Dispel Magic"] = 528,
			["Purify"] = 527,
			["Pain Suppression"] = 33206,
			["Power Word: Barrier"] = 62618,
		},
		["Discipline_Talents"] = {
			["Evangelism"] = 246287,
			["Schism"] = 214621,
			["Mindbender"] = 123040,
			["Halo"] = 120517,
			["Shadow Covenant"] = 204065,
			["Angelic Feather"] = 121536,
			["Power Word: Solace"] = 129250,
			["Divine Star"] = 110744,
			["Shining Force"] = 204263,
			["Luminous Barrier"] = 271466,
			["Purge the Wicked"] = 204197,
		},
		["Shadow_Talents"] = {
			["Mindbender"] = 200174,
			["Dark Void"] = 263346,
			["Void Torrent"] = 263165,
			["Shadow Word: Death"] = 32379,
			["Shadow Crash"] = 205385,
			["Shadow Word: Void"] = 205351,
			["Psychic Horror"] = 64044,
			["Mind Bomb"] = 205369,
			["Surrender to Madness"] = 193223,
			["Dark Ascension"] = 280711,
		},
	},
	["HUNTER"] = {
		["Beast Mastery_Talents"] = {
			["Spitting Cobra"] = 194407,
			["Barrage"] = 120360,
			["A Murder of Crows"] = 131894,
			["Camouflage"] = 199483,
			["Binding Shot"] = 109248,
			["Stampede"] = 201430,
			["Chimaera Shot"] = 53209,
			["Dire Beast"] = 120679,
		},
		["Marksmanship_Talents"] = {
			["Piercing Shot"] = 198670,
			["Camouflage"] = 199483,
			["Serpent Sting"] = 271788,
			["Explosive Shot"] = 212431,
			["Double Tap"] = 260402,
			["Hunter's Mark"] = 257284,
			["Binding Shot"] = 109248,
			["A Murder of Crows"] = 131894,
			["Barrage"] = 120360,
		},
		["Beast Mastery_PVPTalents"] = {
			["Spider Sting"] = 202914,
			["Dire Beast: Basilisk"] = 205691,
			["Hi-Explosive Trap"] = 236776,
			["Viper Sting"] = 202797,
			["Scorpid Sting"] = 202900,
			["Gladiator's Medallion"] = 208683,
			["Dire Beast: Hawk"] = 208652,
			["Interlope"] = 248518,
			["Roar of Sacrifice"] = 53480,
		},
		["Flyouts"] = {
			["Call Pet"] = {
				["Call Pet 3"] = 83243,
				["Call Pet 4"] = 83244,
				["Call Pet 5"] = 83245,
				["Call Pet 2"] = 83242,
				["Call Pet 1"] = 883,
			},
			["Pet Utility"] = {
				["Beast Lore"] = 1462,
				["Feed Pet"] = 6991,
				["Tame Beast"] = 1515,
				["Revive Pet"] = 982,
				["Dismiss Pet"] = 2641,
			},
		},
		["Pets"] = {
			["Ferocity"] = {
				["Growl"] = 2649,
				["Primal Rage"] = 272678,
				["Smack"] = 49966,
				["Master's Call"] = 272682,
				["Dash"] = 61684,
				["Claw"] = 16827,
				["Survival of the Fittest"] = 272679,
				["Bite"] = 17253,
			},
			["Mechanical"] = {
				["Defense Matrix"] = 263868,
			},
			["Worm"] = {
				["Acid Spit"] = 263446,
				["Burrow Attack"] = 93433,
			},
			["Stag"] = {
				["Nature's Grace"] = 264266,
			},
			["Wasp"] = {
				["Toxic Sting"] = 263858,
			},
			["Quilen"] = {
				["Stone Armor"] = 160049,
				["Eternal Guardian"] = 267922,
			},
			["Basilisk"] = {
				["Petrifying Gaze"] = 263841,
			},
			["Silithid"] = {
				["Tendon Rip"] = 160065,
				["Dune Strider"] = 280151,
			},
			["Lizard"] = {
				["Grievous Bite"] = 279362,
			},
			["Water Strider"] = {
				["Surface Trot"] = 126311,
				["Soothing Water"] = 264262,
			},
			["Ravager"] = {
				["Ravage"] = 263857,
			},
			["Scorpid"] = {
				["Deadly Sting"] = 160060,
			},
			["Scalehide"] = {
				["Scale Shield"] = 263865,
			},
			["Oxen"] = {
				["Niuzao's Fortitude"] = 264023,
			},
			["Hydra"] = {
				["Acid Bite"] = 263863,
			},
			["Bear"] = {
				["Rest"] = 94019,
			},
			["Beetle"] = {
				["Harden Carapace"] = 90339,
			},
			["Direhorn"] = {
				["Gore"] = 263861,
			},
			["Clefthoof"] = {
				["Blood of the Rhino"] = 280069,
				["Thick Hide"] = 160057,
			},
			["Crocolisk"] = {
				["Ankle Crack"] = 50433,
			},
			["Dog"] = {
				["Lock Jaw"] = 263423,
			},
			["Crab"] = {
				["Pin"] = 50245,
			},
			["Blood Beast"] = {
				["Blood Bolt"] = 288962,
			},
			["Pterrordax"] = {
				["Updraft"] = 160007,
				["Ancient Hide"] = 279399,
			},
			["Warp Stalker"] = {
				["Warp Time"] = 35346,
			},
			["Hyena"] = {
				["Infected Bite"] = 263853,
			},
			["Devilsaur"] = {
				["Feast"] = 159953,
				["Monstrous Bite"] = 54680,
			},
			["Dragonhawk"] = {
				["Dragon's Guile"] = 263887,
			},
			["Sporebat"] = {
				["Spore Cloud"] = 264056,
			},
			["Fox"] = {
				["Play"] = 90347,
				["Agile Reflexes"] = 160011,
			},
			["Monkey"] = {
				["Primal Agility"] = 160044,
			},
			["Gorilla"] = {
				["Silverback"] = 263939,
			},
			["Moth"] = {
				["Serenity Dust"] = 264055,
			},
			["Tenacity"] = {
				["Growl"] = 2649,
				["Primal Rage"] = 272678,
				["Smack"] = 49966,
				["Master's Call"] = 272682,
				["Dash"] = 61684,
				["Claw"] = 16827,
				["Survival of the Fittest"] = 264735,
				["Bite"] = 17253,
			},
			["Ray"] = {
				["Nether Shock"] = 264264,
			},
			["Toad"] = {
				["Swarm of Flies"] = 279336,
			},
			["Cat"] = {
				["Catlike Reflexes"] = 263892,
				["Prowl"] = 24450,
			},
			["Bat"] = {
				["Sonic Blast"] = 264263,
			},
			["Rodent"] = {
				["Gnaw"] = 263856,
				["Rest"] = 126364,
			},
			["Wolf"] = {
				["Furious Bite"] = 263840,
			},
			["Shale Spider"] = {
				["Solid Shell"] = 160063,
			},
			["Carrion Bird"] = {
				["Bloody Screech"] = 24423,
			},
			["Tallstrider"] = {
				["Dust Cloud"] = 50285,
			},
			["Riverbeast"] = {
				["Gruesome Bite"] = 160018,
			},
			["Spider"] = {
				["Web Spray"] = 160067,
			},
			["Serpent"] = {
				["Serpent's Swiftness"] = 263904,
			},
			["Bird of Prey"] = {
				["Trick"] = 94022,
				["Talon Rend"] = 263852,
			},
			["Krolusk"] = {
				["Bulwark"] = 279410,
			},
			["Core Hound"] = {
				["Molten Hide"] = 159788,
				["Obsidian Skin"] = 263867,
			},
			["Crane"] = {
				["Chi-Ji's Tranquility"] = 264028,
				["Trick"] = 126259,
			},
			["Boar"] = {
				["Bristle"] = 263869,
			},
			["Turtle"] = {
				["Shell Shield"] = 26064,
			},
			["Wind Serpent"] = {
				["Winged Agility"] = 264360,
			},
			["Feathermane"] = {
				["Feather Flurry"] = 263916,
				["Updraft"] = 160007,
			},
			["Chimaera"] = {
				["Froststorm Breath"] = 92380,
				["Frost Breath"] = 54644,
			},
			["Raptor"] = {
				["Savage Rend"] = 263854,
			},
			["Spirit Beast"] = {
				["Spirit Walk"] = 90328,
				["Spirit Shock"] = 264265,
				["Spirit Mend"] = 90361,
			},
			["Cunning"] = {
				["Growl"] = 2649,
				["Primal Rage"] = 272678,
				["Smack"] = 49966,
				["Master's Call"] = 53271,
				["Dash"] = 61684,
				["Claw"] = 16827,
				["Survival of the Fittest"] = 272679,
				["Bite"] = 17253,
			},
		},
		["Marksmanship_PVPTalents"] = {
			["Spider Sting"] = 202914,
			["Dire Beast: Basilisk"] = 205691,
			["Hi-Explosive Trap"] = 236776,
			["Viper Sting"] = 202797,
			["Scorpid Sting"] = 202900,
			["Gladiator's Medallion"] = 208683,
			["Dire Beast: Hawk"] = 208652,
			["Interlope"] = 248518,
			["Roar of Sacrifice"] = 53480,
		},
		["Survival"] = {
			["Harpoon"] = 190925,
			["Flare"] = 1543,
			["Command Pet"] = 272651,
			["Kill Command"] = 259489,
			["Feign Death"] = 5384,
			["Serpent Sting"] = 259491,
			["Muzzle"] = 187707,
			["Tar Trap"] = 187698,
			["Aspect of the Turtle"] = 186265,
			["Wildfire Bomb"] = 259495,
			["Raptor Strike"] = 186270,
			["Pet Utility"] = 103,
			["Wing Clip"] = 195645,
			["Misdirection"] = 34477,
			["Coordinated Assault"] = 266779,
			["Aspect of the Eagle"] = 186289,
			["Carve"] = 187708,
			["Eagle Eye"] = 6197,
			["Exhilaration"] = 109304,
			["Disengage"] = 781,
			["Aspect of the Cheetah"] = 186257,
			["Intimidation"] = 19577,
			["Freezing Trap"] = 187650,
			["Call Pet"] = 9,
		},
		["Survival_Talents"] = {
			["Chakrams"] = 259391,
			["Flanking Strike"] = 269751,
			["Steel Trap"] = 162488,
			["A Murder of Crows"] = 131894,
			["Butchery"] = 212436,
			["Mongoose Bite"] = 259387,
			["Camouflage"] = 199483,
			["Binding Shot"] = 109248,
		},
		["Survival_PVPTalents"] = {
			["Spider Sting"] = 202914,
			["Dire Beast: Basilisk"] = 205691,
			["Hi-Explosive Trap"] = 236776,
			["Viper Sting"] = 202797,
			["Scorpid Sting"] = 202900,
			["Gladiator's Medallion"] = 208683,
			["Dire Beast: Hawk"] = 208652,
			["Interlope"] = 248518,
			["Roar of Sacrifice"] = 53480,
		},
		["Beast Mastery"] = {
			["Pet Utility"] = 103,
			["Call Pet"] = 9,
			["Kill Command"] = 34026,
			["Feign Death"] = 5384,
			["Misdirection"] = 34477,
			["Tar Trap"] = 187698,
			["Multi-Shot"] = 2643,
			["Aspect of the Turtle"] = 186265,
			["Disengage"] = 781,
			["Primal Rage"] = 272651,
			["Aspect of the Wild"] = 193530,
			["Counter Shot"] = 147362,
			["Freezing Trap"] = 187650,
			["Bestial Wrath"] = 19574,
			["Intimidation"] = 19577,
			["Barbed Shot"] = 217200,
			["Aspect of the Cheetah"] = 186257,
			["Exhilaration"] = 109304,
			["Flare"] = 1543,
			["Eagle Eye"] = 6197,
			["Concussive Shot"] = 5116,
			["Survival of the Fittest"] = 272651,
			["Cobra Shot"] = 193455,
		},
		["Marksmanship"] = {
			["Pet Utility"] = 103,
			["Flare"] = 1543,
			["Rapid Fire"] = 257044,
			["Command Pet"] = 272651,
			["Feign Death"] = 5384,
			["Misdirection"] = 34477,
			["Aimed Shot"] = 19434,
			["Tar Trap"] = 187698,
			["Multi-Shot"] = 257620,
			["Aspect of the Turtle"] = 186265,
			["Disengage"] = 781,
			["Trueshot"] = 288613,
			["Counter Shot"] = 147362,
			["Arcane Shot"] = 185358,
			["Steady Shot"] = 56641,
			["Aspect of the Cheetah"] = 186257,
			["Exhilaration"] = 109304,
			["Bursting Shot"] = 186387,
			["Call Pet"] = 9,
			["Concussive Shot"] = 5116,
			["Freezing Trap"] = 187650,
			["Eagle Eye"] = 6197,
		},
	},
	["WARLOCK"] = {
		["Destruction_Talents"] = {
			["Grimoire of Sacrifice"] = 108503,
			["Dark Pact"] = 108416,
			["Mortal Coil"] = 6789,
			["Demonic Circle"] = 268358,
			["Channel Demonfire"] = 196447,
			["Shadowburn"] = 17877,
			["Cataclysm"] = 152108,
			["Soul Fire"] = 6353,
			["Dark Soul: Instability"] = 113858,
			["Burning Rush"] = 111400,
		},
		["Affliction"] = {
			["Corruption"] = 172,
			["Shadowfury"] = 30283,
			["Soulstone"] = 20707,
			["Command Demon"] = 119898,
			["Summon Darkglare"] = 205180,
			["Agony"] = 980,
			["Ritual of Summoning"] = 698,
			["Health Funnel"] = 755,
			["Eye of Kilrogg"] = 126,
			["Fear"] = 5782,
			["Demonic Gateway"] = 111771,
			["Drain Life"] = 234153,
			["Enslave Demon"] = 1098,
			["Shadow Bolt"] = 232670,
			["Unending Resolve"] = 104773,
			["Create Healthstone"] = 6201,
			["Unending Breath"] = 5697,
			["Seed of Corruption"] = 27243,
			["Unstable Affliction"] = 30108,
			["Summon Demon"] = 10,
			["Create Soulwell"] = 29893,
			["Banish"] = 710,
		},
		["Affliction_Talents"] = {
			["Grimoire of Sacrifice"] = 108503,
			["Siphon Life"] = 63106,
			["Mortal Coil"] = 6789,
			["Demonic Circle"] = 268358,
			["Drain Soul"] = 198590,
			["Phantom Singularity"] = 205179,
			["Dark Soul: Misery"] = 113860,
			["Dark Pact"] = 108416,
			["Haunt"] = 48181,
			["Burning Rush"] = 111400,
			["Deathbolt"] = 264106,
			["Vile Taint"] = 278350,
		},
		["Pets"] = {
			["Voidlord"] = {
				["Suffering"] = 119907,
				["Consuming Shadows"] = 3716,
				["Void Shield"] = 115236,
				["Shadow Bulwark"] = 17767,
				["Threatening Presence"] = 134477,
			},
			["Voidwalker"] = {
				["Suffering"] = 17735,
				["Consuming Shadows"] = 3716,
				["Shadow Bulwark"] = 17767,
				["Threatening Presence"] = 112042,
			},
			["Shivarra"] = {
				["Mesmerize"] = 115268,
				["Lesser Invisibility"] = 7870,
				["Bladedance"] = 115748,
				["Fellash"] = 115770,
			},
			["Observer"] = {
				["Optical Blast"] = 115781,
				["Devour Magic"] = 19505,
				["Tongue Lash"] = 115778,
			},
			["Wrathguard"] = {
				["Mortal Cleave"] = 115625,
				["Threatening Presence"] = 134477,
				["Wrathstorm"] = 115831,
				["Axe Toss"] = 89766,
				["Pursuit"] = 30151,
			},
			["Succubus"] = {
				["Whiplash"] = 6360,
				["Lesser Invisibility"] = 7870,
				["Lash of Pain"] = 7814,
				["Seduction"] = 6358,
			},
			["Felguard"] = {
				["Threatening Presence"] = 134477,
				["Felstorm"] = 89751,
				["Legion Strike"] = 30213,
				["Pursuit"] = 30151,
				["Axe Toss"] = 89766,
			},
			["Felhunter"] = {
				["Devour Magic"] = 19505,
				["Spell Lock"] = 119910,
				["Shadow Bite"] = 54049,
			},
			["Fel Imp"] = {
				["Felbolt"] = 115746,
				["Cauterize Master"] = 119905,
				["Sear Magic"] = 115276,
				["Flee"] = 89792,
			},
			["Imp"] = {
				["Flee"] = 89792,
				["Singe Magic"] = 89808,
				["Firebolt"] = 3110,
			},
		},
		["Affliction_PVPTalents"] = {
			["Call Felhunter"] = 212619,
			["Singe Magic"] = 212623,
			["Casting Circle"] = 221703,
			["Curse of Tongues"] = 199890,
			["Call Fel Lord"] = 212459,
			["Nether Ward"] = 212295,
			["Curse of Weakness"] = 199892,
			["Gladiator's Medallion"] = 208683,
			["Call Observer"] = 201996,
			["Bane of Havoc"] = 200546,
			["Demon Armor"] = 285933,
			["Curse of Fragility"] = 199954,
		},
		["Destruction"] = {
			["Shadowfury"] = 30283,
			["Soulstone"] = 20707,
			["Command Demon"] = 119898,
			["Create Soulwell"] = 29893,
			["Conflagrate"] = 17962,
			["Ritual of Summoning"] = 698,
			["Health Funnel"] = 755,
			["Eye of Kilrogg"] = 126,
			["Shadow Bulwark"] = 119898,
			["Fear"] = 5782,
			["Demonic Gateway"] = 111771,
			["Immolate"] = 348,
			["Incinerate"] = 29722,
			["Banish"] = 710,
			["Unending Breath"] = 5697,
			["Enslave Demon"] = 1098,
			["Create Healthstone"] = 6201,
			["Chaos Bolt"] = 116858,
			["Havoc"] = 80240,
			["Summon Infernal"] = 1122,
			["Drain Life"] = 234153,
			["Summon Demon"] = 10,
			["Unending Resolve"] = 104773,
			["Rain of Fire"] = 5740,
		},
		["Demonology_PVPTalents"] = {
			["Call Felhunter"] = 212619,
			["Singe Magic"] = 212623,
			["Casting Circle"] = 221703,
			["Curse of Tongues"] = 199890,
			["Call Fel Lord"] = 212459,
			["Nether Ward"] = 212295,
			["Curse of Weakness"] = 199892,
			["Gladiator's Medallion"] = 208683,
			["Call Observer"] = 201996,
			["Bane of Havoc"] = 200546,
			["Demon Armor"] = 285933,
			["Curse of Fragility"] = 199954,
		},
		["Demonology"] = {
			["Call Dreadstalkers"] = 104316,
			["Soulstone"] = 20707,
			["Implosion"] = 196277,
			["Create Soulwell"] = 29893,
			["Summon Demonic Tyrant"] = 265187,
			["Ritual of Summoning"] = 698,
			["Health Funnel"] = 755,
			["Unending Resolve"] = 104773,
			["Fear"] = 5782,
			["Banish"] = 710,
			["Demonic Gateway"] = 111771,
			["Enslave Demon"] = 1098,
			["Hand of Gul'dan"] = 105174,
			["Drain Life"] = 234153,
			["Unending Breath"] = 5697,
			["Shadow Bolt"] = 686,
			["Eye of Kilrogg"] = 126,
			["Create Healthstone"] = 6201,
			["Shadowfury"] = 30283,
			["Command Demon"] = 119898,
			["Demonbolt"] = 264178,
			["Summon Demon"] = 10,
			["Seduction"] = 119898,
			["Axe Toss"] = 119898,
		},
		["Demonology_Talents"] = {
			["Dark Pact"] = 108416,
			["Demonic Strength"] = 267171,
			["Demonic Circle"] = 268358,
			["Soul Strike"] = 264057,
			["Summon Vilefiend"] = 264119,
			["Grimoire: Felguard"] = 111898,
			["Doom"] = 265412,
			["Nether Portal"] = 267217,
			["Power Siphon"] = 264130,
			["Mortal Coil"] = 6789,
			["Burning Rush"] = 111400,
			["Bilescourge Bombers"] = 267211,
		},
		["Destruction_PVPTalents"] = {
			["Call Felhunter"] = 212619,
			["Singe Magic"] = 212623,
			["Casting Circle"] = 221703,
			["Curse of Tongues"] = 199890,
			["Call Fel Lord"] = 212459,
			["Nether Ward"] = 212295,
			["Curse of Weakness"] = 199892,
			["Gladiator's Medallion"] = 208683,
			["Call Observer"] = 201996,
			["Bane of Havoc"] = 200546,
			["Demon Armor"] = 285933,
			["Curse of Fragility"] = 199954,
		},
		["Flyouts"] = {
			["Summon Demon"] = {
				["Summon Imp"] = 688,
				["Summon Wrathguard"] = 112870,
				["Summon Voidlord"] = 112867,
				["Summon Felhunter"] = 691,
				["Summon Voidwalker"] = 697,
				["Summon Succubus"] = 712,
				["Summon Shivarra"] = 112868,
				["Summon Observer"] = 112869,
				["Summon Fel Imp"] = 112866,
				["Summon Felguard"] = 30146,
			},
		},
	},
	["DEMONHUNTER"] = {
		["Havoc_Talents"] = {
			["Nemesis"] = 206491,
			["Dark Slash"] = 258860,
			["Netherwalk"] = 196555,
			["Fel Eruption"] = 211881,
			["Felblade"] = 232893,
			["Fel Barrage"] = 258925,
			["Immolation Aura"] = 258920,
		},
		["Vengeance_Talents"] = {
			["Fracture"] = 263642,
			["Sigil of Chains"] = 202138,
			["Fel Devastation"] = 212084,
			["Felblade"] = 232893,
			["Soul Barrier"] = 263648,
			["Spirit Bomb"] = 247454,
		},
		["Havoc"] = {
			["Blur"] = 198589,
			["Chaos Nova"] = 179057,
			["Torment"] = 281854,
			["Metamorphosis"] = 191427,
			["Demon's Bite"] = 162243,
			["Darkness"] = 196718,
			["Eye Beam"] = 198013,
			["Chaos Strike"] = 162794,
			["Spectral Sight"] = 188501,
			["Fel Rush"] = 195072,
			["Disrupt"] = 183752,
			["Consume Magic"] = 278326,
			["Glide"] = 131347,
			["Throw Glaive"] = 185123,
			["Vengeful Retreat"] = 198793,
			["Blade Dance"] = 188499,
			["Imprison"] = 217832,
		},
		["Vengeance"] = {
			["Soul Cleave"] = 228477,
			["Torment"] = 185245,
			["Fiery Brand"] = 204021,
			["Metamorphosis"] = 187827,
			["Shear"] = 203782,
			["Imprison"] = 217832,
			["Demon Spikes"] = 203720,
			["Spectral Sight"] = 188501,
			["Sigil of Misery"] = 207684,
			["Disrupt"] = 183752,
			["Consume Magic"] = 278326,
			["Glide"] = 131347,
			["Throw Glaive"] = 204157,
			["Sigil of Flame"] = 204596,
			["Sigil of Silence"] = 202137,
			["Infernal Strike"] = 189110,
			["Immolation Aura"] = 178740,
		},
		["Havoc_PVPTalents"] = {
			["Mana Rift"] = 235903,
			["Gladiator's Medallion"] = 208683,
			["Eye of Leotheras"] = 206649,
			["Rain from Above"] = 206803,
			["Mana Break"] = 203704,
			["Reverse Magic"] = 205604,
		},
		["Vengeance_PVPTalents"] = {
			["Mana Rift"] = 235903,
			["Gladiator's Medallion"] = 208683,
			["Eye of Leotheras"] = 206649,
			["Rain from Above"] = 206803,
			["Mana Break"] = 203704,
			["Reverse Magic"] = 205604,
		},
	},
	["ROGUE"] = {
		["Subtlety_PVPTalents"] = {
			["Death from Above"] = 269513,
			["Neurotoxin"] = 206328,
			["Gladiator's Medallion"] = 208683,
			["Shiv"] = 248744,
			["Smoke Bomb"] = 212182,
		},
		["Assassination_PVPTalents"] = {
			["Death from Above"] = 269513,
			["Neurotoxin"] = 206328,
			["Gladiator's Medallion"] = 208683,
			["Shiv"] = 248744,
			["Smoke Bomb"] = 212182,
		},
		["Assassination"] = {
			["Sprint"] = 2983,
			["Evasion"] = 5277,
			["Garrote"] = 703,
			["Envenom"] = 196819,
			["Crimson Vial"] = 185311,
			["Shadowstep"] = 36554,
			["Rupture"] = 1943,
			["Cloak of Shadows"] = 31224,
			["Blind"] = 2094,
			["Poisons"] = 66,
			["Kick"] = 1766,
			["Vendetta"] = 79140,
			["Poisoned Knife"] = 185565,
			["Pick Pocket"] = 921,
			["Fan of Knives"] = 51723,
			["Mutilate"] = 1752,
			["Pick Lock"] = 1804,
			["Vanish"] = 1856,
			["Shroud of Concealment"] = 114018,
			["Distract"] = 1725,
			["Stealth"] = 1784,
			["Feint"] = 1966,
			["Sap"] = 6770,
			["Kidney Shot"] = 408,
			["Wound Poison"] = 8679,
			["Tricks of the Trade"] = 57934,
			["Cheap Shot"] = 1833,
			["Eviscerate"] = 196819,
		},
		["Assassination_Talents"] = {
			["Crimson Tempest"] = 121411,
			["Blindside"] = 111240,
			["Marked for Death"] = 137619,
			["Toxic Blade"] = 245388,
			["Exsanguinate"] = 200806,
		},
		["Subtlety"] = {
			["Sprint"] = 2983,
			["Evasion"] = 5277,
			["Backstab"] = 53,
			["Symbols of Death"] = 212283,
			["Crimson Vial"] = 185311,
			["Shadowstep"] = 36554,
			["Shadow Blades"] = 121471,
			["Shadowstrike"] = 185438,
			["Eviscerate"] = 196819,
			["Shadow Dance"] = 185313,
			["Poisons"] = 66,
			["Kick"] = 1766,
			["Vanish"] = 1856,
			["Pick Pocket"] = 921,
			["Blind"] = 2094,
			["Nightblade"] = 195452,
			["Pick Lock"] = 1804,
			["Stealth"] = 1784,
			["Shroud of Concealment"] = 114018,
			["Distract"] = 1725,
			["Kidney Shot"] = 408,
			["Shuriken Storm"] = 197835,
			["Sap"] = 6770,
			["Shuriken Toss"] = 114014,
			["Feint"] = 1966,
			["Tricks of the Trade"] = 57934,
			["Cheap Shot"] = 1833,
			["Cloak of Shadows"] = 31224,
		},
		["Flyouts"] = {
			["Poisons"] = {
				["Leeching Poison"] = 108211,
				["Crippling Poison"] = 3408,
				["Wound Poison"] = 8679,
				["Deadly Poison"] = 2823,
			},
		},
		["Outlaw_Talents"] = {
			["Slice and Dice"] = 5171,
			["Ghostly Strike"] = 196937,
			["Blade Rush"] = 271877,
			["Marked for Death"] = 137619,
			["Killing Spree"] = 51690,
		},
		["Outlaw"] = {
			["Sprint"] = 2983,
			["Vanish"] = 1856,
			["Riposte"] = 199754,
			["Pistol Shot"] = 185763,
			["Crimson Vial"] = 185311,
			["Blade Flurry"] = 13877,
			["Between the Eyes"] = 199804,
			["Dispatch"] = 2098,
			["Grappling Hook"] = 195457,
			["Pick Pocket"] = 921,
			["Poisons"] = 66,
			["Kick"] = 1766,
			["Ambush"] = 8676,
			["Blind"] = 2094,
			["Gouge"] = 1776,
			["Pick Lock"] = 1804,
			["Roll the Bones"] = 193316,
			["Shroud of Concealment"] = 114018,
			["Distract"] = 1725,
			["Adrenaline Rush"] = 13750,
			["Sinister Strike"] = 193315,
			["Sap"] = 6770,
			["Stealth"] = 1784,
			["Feint"] = 1966,
			["Tricks of the Trade"] = 57934,
			["Cheap Shot"] = 1833,
			["Cloak of Shadows"] = 31224,
		},
		["Subtlety_Talents"] = {
			["Marked for Death"] = 137619,
			["Gloomblade"] = 200758,
			["Secret Technique"] = 280719,
			["Shuriken Tornado"] = 277925,
		},
		["Outlaw_PVPTalents"] = {
			["Death from Above"] = 269513,
			["Neurotoxin"] = 206328,
			["Gladiator's Medallion"] = 208683,
			["Shiv"] = 248744,
			["Smoke Bomb"] = 212182,
		},
	},
	["DRUID"] = {
		["Restoration_PVPTalents"] = {
			["Thorns"] = 305497,
			["Cyclone"] = 33786,
			["Rip and Tear"] = 203242,
			["Gladiator's Medallion"] = 208683,
		},
		["Feral_Talents"] = {
			["Mass Entanglement"] = 102359,
			["Brutal Slash"] = 202028,
			["Savage Roar"] = 52610,
			["Typhoon"] = 132469,
			["Feral Frenzy"] = 274837,
			["Tiger Dash"] = 252216,
			["Wild Charge"] = 102401,
			["Primal Wrath"] = 285381,
			["Renewal"] = 108238,
			["Mighty Bash"] = 5211,
			["Incarnation: King of the Jungle"] = 102543,
		},
		["Feral"] = {
			["Stampeding Roar"] = 106898,
			["Skull Bash"] = 106839,
			["Entangling Roots"] = 339,
			["Mangle"] = 33917,
			["Charm Woodland Creature"] = 127757,
			["Hibernate"] = 2637,
			["Shred"] = 5221,
			["Tiger's Fury"] = 5217,
			["Remove Corruption"] = 2782,
			["Rebirth"] = 20484,
			["Ironfur"] = 192081,
			["Thrash"] = 106832,
			["Travel Form"] = 783,
			["Prowl"] = 5215,
			["Regrowth"] = 8936,
			["Ferocious Bite"] = 22568,
			["Growl"] = 6795,
			["Revive"] = 50769,
			["Frenzied Regeneration"] = 22842,
			["Treant Form"] = 114282,
			["Soothe"] = 2908,
			["Rake"] = 1822,
			["Rip"] = 1079,
			["Moonfire"] = 8921,
			["Maim"] = 22570,
			["Cat Form"] = 768,
			["Survival Instincts"] = 61336,
			["Teleport: Moonglade"] = 18960,
			["Stag Form"] = 210053,
			["Berserk"] = 106951,
			["Swipe"] = 213764,
			["Dash"] = 1850,
			["Bear Form"] = 5487,
			["Flap"] = 164862,
			["Dreamwalk"] = 193753,
		},
		["Feral_PVPTalents"] = {
			["Thorns"] = 305497,
			["Cyclone"] = 33786,
			["Rip and Tear"] = 203242,
			["Gladiator's Medallion"] = 208683,
		},
		["Guardian_Talents"] = {
			["Mass Entanglement"] = 102359,
			["Bristling Fur"] = 155835,
			["Lunar Beam"] = 204066,
			["Pulverize"] = 80313,
			["Typhoon"] = 132469,
			["Mighty Bash"] = 5211,
			["Wild Charge"] = 102401,
			["Ursol's Vortex"] = 102793,
			["Incarnation: Guardian of Ursoc"] = 102558,
			["Tiger Dash"] = 252216,
		},
		["Balance"] = {
			["Solar Wrath"] = 190984,
			["Prowl"] = 5215,
			["Lunar Strike"] = 194153,
			["Regrowth"] = 8936,
			["Bear Form"] = 5487,
			["Innervate"] = 29166,
			["Entangling Roots"] = 339,
			["Celestial Alignment"] = 194223,
			["Growl"] = 6795,
			["Revive"] = 50769,
			["Stag Form"] = 210053,
			["Rebirth"] = 20484,
			["Mangle"] = 33917,
			["Starsurge"] = 78674,
			["Charm Woodland Creature"] = 127757,
			["Hibernate"] = 2637,
			["Moonfire"] = 8921,
			["Moonkin Form"] = 24858,
			["Shred"] = 5221,
			["Remove Corruption"] = 2782,
			["Starfall"] = 191034,
			["Soothe"] = 2908,
			["Cat Form"] = 768,
			["Barkskin"] = 22812,
			["Flap"] = 164862,
			["Teleport: Moonglade"] = 18960,
			["Treant Form"] = 114282,
			["Dreamwalk"] = 193753,
			["Dash"] = 1850,
			["Sunfire"] = 93402,
			["Solar Beam"] = 78675,
			["Travel Form"] = 783,
		},
		["Guardian"] = {
			["Thrash"] = 106832,
			["Prowl"] = 5215,
			["Stampeding Roar"] = 106898,
			["Regrowth"] = 8936,
			["Entangling Roots"] = 339,
			["Skull Bash"] = 106839,
			["Maul"] = 6807,
			["Dash"] = 1850,
			["Growl"] = 6795,
			["Dreamwalk"] = 193753,
			["Treant Form"] = 114282,
			["Stag Form"] = 210053,
			["Mangle"] = 33917,
			["Charm Woodland Creature"] = 127757,
			["Revive"] = 50769,
			["Swipe"] = 213764,
			["Cat Form"] = 768,
			["Flap"] = 164862,
			["Shred"] = 5221,
			["Soothe"] = 2908,
			["Rebirth"] = 20484,
			["Remove Corruption"] = 2782,
			["Moonfire"] = 8921,
			["Barkskin"] = 22812,
			["Incapacitating Roar"] = 99,
			["Teleport: Moonglade"] = 18960,
			["Ironfur"] = 192081,
			["Frenzied Regeneration"] = 22842,
			["Survival Instincts"] = 61336,
			["Bear Form"] = 5487,
			["Hibernate"] = 2637,
			["Travel Form"] = 783,
		},
		["Restoration_Talents"] = {
			["Mass Entanglement"] = 102359,
			["Flourish"] = 197721,
			["Typhoon"] = 132469,
			["Mighty Bash"] = 5211,
			["Wild Charge"] = 102401,
			["Renewal"] = 108238,
			["Incarnation: Tree of Life"] = 33891,
			["Cenarion Ward"] = 102351,
			["Tiger Dash"] = 252216,
		},
		["Balance_PVPTalents"] = {
			["Thorns"] = 305497,
			["Cyclone"] = 33786,
			["Rip and Tear"] = 203242,
			["Gladiator's Medallion"] = 208683,
		},
		["Guardian_PVPTalents"] = {
			["Thorns"] = 305497,
			["Cyclone"] = 33786,
			["Rip and Tear"] = 203242,
			["Gladiator's Medallion"] = 208683,
		},
		["Restoration"] = {
			["Swiftmend"] = 18562,
			["Solar Wrath"] = 5176,
			["Revitalize"] = 212040,
			["Nature's Cure"] = 88423,
			["Mangle"] = 33917,
			["Efflorescence"] = 145205,
			["Charm Woodland Creature"] = 127757,
			["Hibernate"] = 2637,
			["Shred"] = 5221,
			["Rebirth"] = 20484,
			["Treant Form"] = 114282,
			["Travel Form"] = 783,
			["Prowl"] = 5215,
			["Tranquility"] = 740,
			["Wild Growth"] = 48438,
			["Lifebloom"] = 33763,
			["Ursol's Vortex"] = 102793,
			["Revive"] = 50769,
			["Dreamwalk"] = 193753,
			["Growl"] = 6795,
			["Rejuvenation"] = 774,
			["Dash"] = 1850,
			["Entangling Roots"] = 339,
			["Cat Form"] = 768,
			["Soothe"] = 2908,
			["Flap"] = 164862,
			["Barkskin"] = 22812,
			["Stag Form"] = 210053,
			["Teleport: Moonglade"] = 18960,
			["Moonfire"] = 8921,
			["Regrowth"] = 8936,
			["Ironbark"] = 102342,
			["Innervate"] = 29166,
			["Sunfire"] = 93402,
			["Bear Form"] = 5487,
		},
		["Balance_Talents"] = {
			["Force of Nature"] = 205636,
			["New Moon"] = 274281,
			["Stellar Flare"] = 202347,
			["Typhoon"] = 132469,
			["Renewal"] = 108238,
			["Warrior of Elune"] = 202425,
			["Mighty Bash"] = 5211,
			["Wild Charge"] = 102401,
			["Tiger Dash"] = 252216,
			["Fury of Elune"] = 202770,
			["Incarnation: Chosen of Elune"] = 102560,
			["Mass Entanglement"] = 102359,
		},
	},
	["MONK"] = {
		["Windwalker_Talents"] = {
			["Chi Burst"] = 123986,
			["Rushing Jade Wind"] = 116847,
			["Fist of the White Tiger"] = 261947,
			["Energizing Elixir"] = 115288,
			["Ring of Peace"] = 116844,
			["Chi Torpedo"] = 115008,
			["Chi Wave"] = 115098,
			["Serenity"] = 152173,
			["Whirling Dragon Punch"] = 152175,
			["Tiger's Lust"] = 116841,
			["Invoke Xuen, the White Tiger"] = 123904,
			["Dampen Harm"] = 122278,
			["Diffuse Magic"] = 122783,
		},
		["Mistweaver_Talents"] = {
			["Chi Burst"] = 123986,
			["Diffuse Magic"] = 122783,
			["Invoke Chi-Ji, the Red Crane"] = 198664,
			["Chi Wave"] = 115098,
			["Ring of Peace"] = 116844,
			["Chi Torpedo"] = 115008,
			["Refreshing Jade Wind"] = 196725,
			["Dampen Harm"] = 122278,
			["Summon Jade Serpent Statue"] = 115313,
			["Tiger's Lust"] = 116841,
			["Healing Elixir"] = 122281,
			["Mana Tea"] = 197908,
			["Song of Chi-Ji"] = 198898,
		},
		["Mistweaver"] = {
			["Life Cocoon"] = 116849,
			["Thunder Focus Tea"] = 116680,
			["Resuscitate"] = 115178,
			["Vivify"] = 116670,
			["Renewing Mist"] = 115151,
			["Leg Sweep"] = 119381,
			["Detox"] = 115450,
			["Roll"] = 109132,
			["Soothing Mist"] = 115175,
			["Transcendence"] = 101643,
			["Revival"] = 115310,
			["Zen Pilgrimage"] = 126892,
			["Fortifying Brew"] = 243435,
			["Reawaken"] = 212051,
			["Transcendence: Transfer"] = 119996,
			["Enveloping Mist"] = 124682,
			["Spinning Crane Kick"] = 101546,
			["Tiger Palm"] = 100780,
			["Blackout Kick"] = 100784,
			["Provoke"] = 115546,
			["Paralysis"] = 115078,
			["Rising Sun Kick"] = 107428,
			["Crackling Jade Lightning"] = 117952,
			["Essence Font"] = 191837,
		},
		["Brewmaster"] = {
			["Resuscitate"] = 115178,
			["Blackout Strike"] = 205523,
			["Breath of Fire"] = 115181,
			["Vivify"] = 116670,
			["Expel Harm"] = 115072,
			["Detox"] = 218164,
			["Roll"] = 109132,
			["Spear Hand Strike"] = 116705,
			["Zen Meditation"] = 115176,
			["Transcendence"] = 101643,
			["Tiger Palm"] = 100780,
			["Fortifying Brew"] = 115203,
			["Leg Sweep"] = 119381,
			["Zen Pilgrimage"] = 126892,
			["Transcendence: Transfer"] = 119996,
			["Purifying Brew"] = 119582,
			["Provoke"] = 115546,
			["Paralysis"] = 115078,
			["Crackling Jade Lightning"] = 117952,
			["Keg Smash"] = 121253,
			["Ironskin Brew"] = 115308,
		},
		["Windwalker"] = {
			["Fists of Fury"] = 113656,
			["Resuscitate"] = 115178,
			["Vivify"] = 116670,
			["Touch of Death"] = 115080,
			["Leg Sweep"] = 119381,
			["Detox"] = 218164,
			["Roll"] = 109132,
			["Touch of Karma"] = 122470,
			["Spear Hand Strike"] = 116705,
			["Storm, Earth, and Fire"] = 137639,
			["Zen Pilgrimage"] = 126892,
			["Transcendence"] = 101643,
			["Spinning Crane Kick"] = 101546,
			["Flying Serpent Kick"] = 101545,
			["Paralysis"] = 115078,
			["Crackling Jade Lightning"] = 117952,
			["Provoke"] = 115546,
			["Blackout Kick"] = 100784,
			["Tiger Tail Sweep"] = 175697,
			["Transcendence: Transfer"] = 119996,
			["Rising Sun Kick"] = 107428,
			["Tiger Palm"] = 100780,
			["Disable"] = 116095,
		},
		["Windwalker_PVPTalents"] = {
			["Gladiator's Medallion"] = 208683,
			["Fortifying Brew"] = 201318,
			["Tigereye Brew"] = 247483,
			["Reverse Harm"] = 287771,
			["Grapple Weapon"] = 233759,
		},
		["Brewmaster_Talents"] = {
			["Chi Burst"] = 123986,
			["Summon Black Ox Statue"] = 115315,
			["Black Ox Brew"] = 115399,
			["Ring of Peace"] = 116844,
			["Chi Torpedo"] = 115008,
			["Chi Wave"] = 115098,
			["Rushing Jade Wind"] = 116847,
			["Invoke Niuzao, the Black Ox"] = 132578,
			["Tiger's Lust"] = 116841,
			["Healing Elixir"] = 122281,
			["Guard"] = 115295,
			["Dampen Harm"] = 122278,
		},
		["Brewmaster_PVPTalents"] = {
			["Gladiator's Medallion"] = 208683,
			["Fortifying Brew"] = 201318,
			["Tigereye Brew"] = 247483,
			["Reverse Harm"] = 287771,
			["Grapple Weapon"] = 233759,
		},
		["Mistweaver_PVPTalents"] = {
			["Gladiator's Medallion"] = 208683,
			["Fortifying Brew"] = 201318,
			["Tigereye Brew"] = 247483,
			["Reverse Harm"] = 287771,
			["Grapple Weapon"] = 233759,
		},
	},
	["PALADIN"] = {
		["Protection"] = {
			["Divine Shield"] = 642,
			["Guardian of Ancient Kings"] = 86659,
			["Judgment"] = 275779,
			["Light of the Protector"] = 184092,
			["Shield of the Righteous"] = 53600,
			["Hammer of the Righteous"] = 53595,
			["Consecration"] = 26573,
			["Avenging Wrath"] = 31884,
			["Redemption"] = 7328,
			["Blessing of Protection"] = 1022,
			["Avenger's Shield"] = 31935,
			["Cleanse Toxins"] = 213644,
			["Lay on Hands"] = 633,
			["Rebuke"] = 96231,
			["Hand of Reckoning"] = 62124,
			["Hammer of Justice"] = 853,
			["Blessing of Sacrifice"] = 6940,
			["Flash of Light"] = 19750,
			["Blessing of Freedom"] = 1044,
			["Ardent Defender"] = 31850,
			["Divine Steed"] = 190784,
		},
		["Holy"] = {
			["Divine Shield"] = 642,
			["Holy Light"] = 82326,
			["Cleanse"] = 4987,
			["Judgment"] = 275773,
			["Redemption"] = 7328,
			["Holy Shock"] = 20473,
			["Hand of Reckoning"] = 62124,
			["Hammer of Justice"] = 853,
			["Consecration"] = 26573,
			["Beacon of Light"] = 53563,
			["Divine Protection"] = 498,
			["Blessing of Sacrifice"] = 6940,
			["Avenging Wrath"] = 31884,
			["Blessing of Protection"] = 1022,
			["Absolution"] = 212056,
			["Crusader Strike"] = 35395,
			["Light of Dawn"] = 85222,
			["Light of the Martyr"] = 183998,
			["Aura Mastery"] = 31821,
			["Flash of Light"] = 19750,
			["Blessing of Freedom"] = 1044,
			["Lay on Hands"] = 633,
			["Divine Steed"] = 190784,
		},
		["Protection_PVPTalents"] = {
			["Cleansing Light"] = 236186,
			["Gladiator's Medallion"] = 208683,
			["Hammer of Reckoning"] = 247675,
			["Blessing of Sanctuary"] = 210256,
			["Divine Favor"] = 210294,
		},
		["Holy_Talents"] = {
			["Holy Avenger"] = 105809,
			["Blinding Light"] = 115750,
			["Beacon of Faith"] = 156910,
			["Bestow Faith"] = 223306,
			["Light's Hammer"] = 114158,
			["Rule of Law"] = 214202,
			["Beacon of Virtue"] = 200025,
			["Avenging Crusader"] = 216331,
			["Holy Prism"] = 114165,
			["Repentance"] = 20066,
		},
		["Holy_PVPTalents"] = {
			["Cleansing Light"] = 236186,
			["Gladiator's Medallion"] = 208683,
			["Hammer of Reckoning"] = 247675,
			["Blessing of Sanctuary"] = 210256,
			["Divine Favor"] = 210294,
		},
		["Retribution_Talents"] = {
			["Word of Glory"] = 210191,
			["Blinding Light"] = 115750,
			["Hammer of Wrath"] = 24275,
			["Justicar's Vengeance"] = 215661,
			["Wake of Ashes"] = 255937,
			["Inquisition"] = 84963,
			["Consecration"] = 205228,
			["Execution Sentence"] = 267798,
			["Eye for an Eye"] = 205191,
			["Crusade"] = 231895,
			["Repentance"] = 20066,
		},
		["Protection_Talents"] = {
			["Bastion of Light"] = 204035,
			["Blessing of Spellwarding"] = 204018,
			["Blessed Hammer"] = 204019,
			["Blinding Light"] = 115750,
			["Seraphim"] = 152262,
			["Hand of the Protector"] = 213652,
			["Aegis of Light"] = 204150,
			["Repentance"] = 20066,
		},
		["Retribution"] = {
			["Divine Shield"] = 642,
			["Avenging Wrath"] = 31884,
			["Divine Storm"] = 53385,
			["Shield of Vengeance"] = 184662,
			["Judgment"] = 20271,
			["Redemption"] = 7328,
			["Hand of Reckoning"] = 62124,
			["Hammer of Justice"] = 853,
			["Cleanse Toxins"] = 213644,
			["Greater Blessing of Kings"] = 203538,
			["Hand of Hindrance"] = 183218,
			["Blade of Justice"] = 184575,
			["Lay on Hands"] = 633,
			["Crusader Strike"] = 35395,
			["Templar's Verdict"] = 85256,
			["Blessing of Protection"] = 1022,
			["Rebuke"] = 96231,
			["Flash of Light"] = 19750,
			["Blessing of Freedom"] = 1044,
			["Greater Blessing of Wisdom"] = 203539,
			["Divine Steed"] = 190784,
		},
		["Retribution_PVPTalents"] = {
			["Cleansing Light"] = 236186,
			["Gladiator's Medallion"] = 208683,
			["Hammer of Reckoning"] = 247675,
			["Blessing of Sanctuary"] = 210256,
			["Divine Favor"] = 210294,
		},
	},
	["METADATA"] = {
		["DEATHKNIGHT"] = {
			["Specs"] = {
				["Unholy"] = 252,
				["Frost"] = 251,
				["Blood"] = 250,
			},
		},
		["WARRIOR"] = {
			["Specs"] = {
				["Fury"] = 72,
				["Protection"] = 73,
				["Arms"] = 71,
			},
		},
		["General"] = {
		},
		["SHAMAN"] = {
			["Specs"] = {
				["Enhancement"] = 263,
				["Elemental"] = 262,
				["Restoration"] = 264,
			},
		},
		["MAGE"] = {
			["Specs"] = {
				["Fire"] = 63,
				["Frost"] = 64,
				["Arcane"] = 62,
			},
		},
		["PRIEST"] = {
			["Specs"] = {
				["Discipline"] = 256,
				["Holy"] = 257,
				["Shadow"] = 258,
			},
		},
		["HUNTER"] = {
			["Specs"] = {
				["Marksmanship"] = 254,
				["Beast Mastery"] = 253,
				["Survival"] = 255,
			},
		},
		["WARLOCK"] = {
			["Specs"] = {
				["Demonology"] = 266,
				["Affliction"] = 265,
				["Destruction"] = 267,
			},
		},
		["DEMONHUNTER"] = {
			["Specs"] = {
				["Havoc"] = 577,
				["Vengeance"] = 581,
			},
		},
		["PALADIN"] = {
			["Specs"] = {
				["Protection"] = 66,
				["Holy"] = 65,
				["Retribution"] = 70,
			},
		},
		["DRUID"] = {
			["Specs"] = {
				["Feral"] = 103,
				["Balance"] = 102,
				["Guardian"] = 104,
				["Restoration"] = 105,
			},
		},
		["MONK"] = {
			["Specs"] = {
				["Mistweaver"] = 270,
				["Brewmaster"] = 268,
				["Windwalker"] = 269,
			},
		},
		["ROGUE"] = {
			["Specs"] = {
				["Outlaw"] = 260,
				["Subtlety"] = 261,
				["Assassination"] = 259,
			},
		},
	},
};

	
-- Helper functions: Default lookup priorities, etc --
------------------------------------------------------

LibSN2SID.libLocal = {
	playerUniversalClassName = "",	-- Player only, gathered upon PLAYER_LOGIN
	playerUniversalRaceName = "",	-- Player only, gathered upon PLAYER_LOGIN
	petFamily = "",
	
	FactionSpells = {
		-- currrentFaction = "",
		["Alliance"] = {
			["MAGE"] = {
				["Flyouts"] = {
					["Portal"] = {
						["Portal: Vale of Eternal Blossoms"] = 132620,
						["Portal: Shattrath"] = 33691,
						["Portal: Tol Barad"] = 88345,
					},
					["Teleport"] = {
						["Teleport: Vale of Eternal Blossoms"] = 132621,
						["Teleport: Shattrath"] = 33690,
						["Teleport: Tol Barad"] = 88342,
					},
				},
			},
		},
		["Horde"] = {
			["MAGE"] = {
				["Flyouts"] = {
					["Portal"] = {
						["Portal: Vale of Eternal Blossoms"] = 132626,
						["Portal: Shattrath"] = 35717,
						["Portal: Tol Barad"] = 88346,
					},
					["Teleport"] = {
						["Teleport: Vale of Eternal Blossoms"] = 132627,
						["Teleport: Shattrath"] = 35715,
						["Teleport: Tol Barad"] = 88344,
					},
				},
			},
		},
		["Neutral"] = {	-- For Pandarens who haven't chosen their faction yet
		},
	},
};
LibSN2SID.SetFaction = function(faction, instanceName)	-- TODO: Move to section "API" bellow !
	-- print(LibSpellName2SID_MAJOR.. ": 2. Player faction = ".. tostring(faction));
	assert((faction == "Alliance") or (faction == "Horde") or (faction == "Neutral"), "Bad argument #1 to LibSpellName2SID.SetFaction(); must be either \"Alliance\" or \"Horde\" (or possibly \"Neutral\").");
	if not LibSN2SID.clients then
		LibSN2SID.clients = {};
	end
	if not LibSN2SID.clients[instanceName] then
		assert(instanceName == LibSpellName2SID_MAJOR, "Bad argument #2 to LibSpellName2SID.SetFaction(); must be a registered instance of ".. LibSpellName2SID_MAJOR);
	end
	-- print(LibSpellName2SID_MAJOR.. ": LibSpellName2SID.SetFaction called with instanceName = ".. tostring(instanceName));
	-- print(LibSpellName2SID_MAJOR.. ": 2. Player currrentFaction = ".. tostring(LibSN2SID.libLocal.FactionSpells.currrentFaction));
	if not LibSN2SID.clients[instanceName].SID then
		LibSN2SID.clients[instanceName].SID = {};
		LibSN2SID.clients[instanceName].LSN = {};
	end
	if not LibSN2SID.clients[instanceName].SID.FactionSpells then
		LibSN2SID.clients[instanceName].SID.FactionSpells = {};
		LibSN2SID.clients[instanceName].LSN.FactionSpells = {};
	end
	if not LibSN2SID.clients[instanceName].SID.FactionSpells.currentFaction then
		LibSN2SID.clients[instanceName].SID.FactionSpells.currentFaction = "";
		LibSN2SID.clients[instanceName].LSN.FactionSpells.currentFaction = "";
	end
	-- Sanity checks and fallback setups done. Now put the new faction spells into place if needed
	if faction ~= LibSN2SID.clients[instanceName].SID.FactionSpells.currentFaction then
		LibSN2SID.clients[instanceName].SID.FactionSpells.currentFaction = faction;
		LibSN2SID.clients[instanceName].LSN.FactionSpells.currentFaction = faction;
		local factionSpells_table = LibSN2SID.libLocal.FactionSpells[faction];	-- For human readers
		-- Copy the spells from the apropriate table of faction sepcifics table to this lib instance
		local classIndex = 1;
		local classKey = (next(factionSpells_table, nil));
		if not classKey then	-- "Neutral" faction has no ... faction spells.
			return false;
		end
		if not LibSN2SID.clients[instanceName].SID.FactionSpells[classKey] then
			LibSN2SID.clients[instanceName].SID.FactionSpells[classKey] = {};
			LibSN2SID.clients[instanceName].LSN.FactionSpells[classKey] = {};
		end
		while classKey do
			-- print(LibSpellName2SID_MAJOR.. ": ".. classIndex.. ": ".. classKey);
			-- print(LibSpellName2SID_MAJOR.. ": type of factionSpells_table[classKey] = ".. tostring(type(factionSpells_table[classKey])));
			local specIndex = 1;
			local specKey = (next(factionSpells_table[classKey], nil));
			if not LibSN2SID.clients[instanceName].SID.FactionSpells[classKey][specKey] then
				LibSN2SID.clients[instanceName].SID.FactionSpells[classKey][specKey] = {};
				LibSN2SID.clients[instanceName].LSN.FactionSpells[classKey][specKey] = {};
			end
			while specKey do
				-- print(LibSpellName2SID_MAJOR.. ": ".. classIndex.. ".".. specIndex.. ": ".. tostring(specKey));
				local contentIndex = 1;
				local contentKey = (next(factionSpells_table[classKey][specKey], nil));
				while contentKey do
					-- print(LibSpellName2SID_MAJOR.. ": ".. classIndex.. ".".. specIndex.. ".".. contentIndex.. ": ".. contentKey);
					if type(factionSpells_table[classKey][specKey][contentKey]) == "table" then -- "Flyouts"->Button or "Pets"->Pet
						local spellIndex = 1;
						local spellKey = (next(factionSpells_table[classKey][specKey][contentKey], nil));
						if not LibSN2SID.clients[instanceName].SID.FactionSpells[classKey][specKey][contentKey] then
							LibSN2SID.clients[instanceName].SID.FactionSpells[classKey][specKey][contentKey] = {};
							LibSN2SID.clients[instanceName].LSN.FactionSpells[classKey][specKey][contentKey] = {};
						end
						while spellKey do
							-- print(LibSpellName2SID_MAJOR.. ": ".. classIndex.. ".".. specIndex.. ".".. contentIndex.. ".".. spellIndex.. ": ".. spellKey);
							LibSN2SID.clients[instanceName].SID.FactionSpells[classKey][specKey][contentKey][spellKey] = factionSpells_table[classKey][specKey][contentKey][spellKey];
							LibSN2SID.clients[instanceName].LSN.FactionSpells[classKey][specKey][contentKey][spellKey] = factionSpells_table[classKey][specKey][contentKey][spellKey];
							-- print(LibSpellName2SID_MAJOR.. ": LibSN2SID.DB\[".. classKey.. "\]\[".. specKey.. "\]\[".. contentKey.. "\]\[".. 
							spellKey = (next(factionSpells_table[classKey][specKey][contentKey], spellKey));
							spellIndex = spellIndex + 1;
							-- Add the spells to the DB, so they can be pulled directly from it
							--  (bypassing both SID and LSN)
							if spellKey and (instanceName == LibSpellName2SID_MAJOR) then
								LibSN2SID.DB[classKey][specKey][contentKey][spellKey] = factionSpells_table[classKey][specKey][contentKey][spellKey];
							end
						end
						
					else
					
						LibSN2SID.clients[instanceName].SID.FactionSpells[classKey][specKey][contentKey] = factionSpells_table[classKey][specKey][contentKey];
						LibSN2SID.clients[instanceName].LSN.FactionSpells[classKey][specKey][contentKey] = factionSpells_table[classKey][specKey][contentKey];
						-- Add the spells to the DB, so they can be pulled directly from it
						--  (bypassing both SID and LSN)
						if contentKey and (instanceName == LibSpellName2SID_MAJOR) then
							-- print(LibSpellName2SID_MAJOR.. ": classKey = ".. tostring(classKey));
							-- print(LibSpellName2SID_MAJOR.. ": specKey = ".. tostring(specKey));
							-- print(LibSpellName2SID_MAJOR.. ": contentKey = ".. tostring(contentKey));
							LibSN2SID.DB[classKey][specKey][contentKey] = factionSpells_table[classKey][specKey][contentKey];
						end
					end
					contentKey = (next(factionSpells_table[classKey][specKey], contentKey));
					contentIndex = contentIndex + 1;
				end
				specKey = (next(factionSpells_table[classKey], specKey));
				specIndex = specIndex + 1;
			end
			classKey = (next(factionSpells_table, classKey));
			classIndex = classIndex + 1;
		end
	end
end
LibSN2SID.libLocal.SetDefaultFaction = function(instanceName)
	local instanceName = instanceName or LibSpellName2SID_MAJOR;
	if instanceName == LibSpellName2SID_MAJOR then
		if not LibSN2SID.clients then
			LibSN2SID.clients = { [LibSpellName2SID_MAJOR] = {}, };
		else
			LibSN2SID.clients[LibSpellName2SID_MAJOR] = {};
		end
	end
	local englishFaction, _ = UnitFactionGroup("player");
	-- print(LibSpellName2SID_MAJOR.. ": 1. Player faction = ".. tostring(englishFaction));
	LibSN2SID.SetFaction(englishFaction, instanceName);
	if instanceName == LibSpellName2SID_MAJOR then
		-- for k, v in pairs(LibSN2SID.clients) do
		local instName = (next(LibSN2SID.clients, nil));
		while instName do
			if (instName ~= LibSpellName2SID_MAJOR) then
				if (not LibSN2SID.clients[instName].FactionSpells) or (not LibSN2SID.clients[instName].FactionSpells.currentFaction) or (LibSN2SID.clients[instName].FactionSpells.currentFaction == "") then
					-- print(LibSpellName2SID_MAJOR.. ": Default faction set to reserved instance name \'".. LibSpellName2SID_MAJOR.. "\'. Will now set the same faction to instance ".. instName);
					LibSN2SID.SetFaction(englishFaction, instName);
				end
			end
			instName = (next(LibSN2SID.clients, instName));
		end
	end
end

LibSN2SID.libLocal.GetEnglishSpecialisationName = function(specID, ...)	-- Any class/spec
	-- Arguments (1 to 2):
		-- specID (number) *mandatory - Specialisation ID for which we want to get the English Name.
		-- universalClassName (string) *optional - Class where the specialisation should be found;
												--  Defaults to the current Player's class.
	-- Returns (2):
		-- engSpecName (string): English name for the given Specialisation; Nil if the spec wasn't
		--  found.
		-- uniClassName (string): Non-localised name of the Class the spec belongs to (given as arg2
		--  or otherwise discovered if the given class was wrong or nil). Nil if the spec wasn't
		--  found.
	--
	-- Look first in the provided universal class name (or the player class if argument is missing)
	local lookupFirstInClass = ... or LibSN2SID.libLocal.playerUniversalClassName;
	-- for engSpecName, DBspecID in pairs(LibSN2SID.DB[lookupFirstInClass].METADATA.Specs) do
	for engSpecName, DBspecID in pairs(LibSN2SID.DB.METADATA[lookupFirstInClass].Specs) do
		if DBspecID == specID then
			return engSpecName, lookupFirstInClass;
		end
	end
	-- Look up the specialisation ID in all other classes
	local generalTabName = (GetSpellTabInfo(1));
	local uniClassName = (next(LibSN2SID.DB, nil));
	while uniClassName do
		if (uniClassName ~= generalTabName) and (uniClassName ~= lookupFirstInClass) and (uniClassName ~= "METADATA") then
			for engSpecName, DBspecID in pairs(LibSN2SID.DB.METADATA[uniClassName].Specs) do
				-- print(uniClassName);
				if DBspecID == specID then
					return engSpecName, uniClassName;
				end
			end
		end
		uniClassName = (next(LibSN2SID.DB, uniClassName));
	end
	-- Could not find the given specID in the database
	return nil, nil;
end

LibSN2SID.libLocal.GetActiveEnglishSpecialisationName = function()	-- Player only
	-- Returns(3):
		-- engSpecName (string) - English name for the active Player Specialisation; Nil if no spec
			-- is active (e.g. if character level < 10).
		-- uniClassName (string) - Non-localised name of the Player Class. Nil if no active spec.
		-- activeSpecID (number) - Specialisation ID for the active spec. Nil if no active spec.
	--
	local activeSpecIndex = (GetSpecialization());
	-- print(tostring(activeSpecIndex));
	if activeSpecIndex then
		local activeSpecID = (GetSpecializationInfo(activeSpecIndex));
		-- print(tostring(activeSpecID));
		return LibSN2SID.libLocal.GetEnglishSpecialisationName(activeSpecID, LibSN2SID.libLocal.playerUniversalClassName), activeSpecID;
	else
		return nil, nil, nil; -- Player does not have an active specialisation
	end
end

-- Lookup order setting functions --

LibSN2SID.libLocal.LookupOrder_table = {};	-- Any class/spec

-- Order to lookup spells in the DB:
-- 1st: Player's class:
	-- 1.1. Active spec baseline spells;
	-- 1.2. Active spec Talents' spells;
	-- 1.3. Active spec PvP Talents' spells;
	-- 1.4. Flyouts (if there are spells for);
	-- 1.5. Pets (if there are spells for);
	-- 1.5.1. Current pet specialization (if there is one) spells;	NOT properly working, pet family
	-- 1.5.2. Current pet fmaily (if there is one) spells;	gets bumped up above pet specicalization
	-- 1.6. Other specs' baseline spells;
	-- 1.7. Other specs' Talents' spells;
	-- 1.8. Other specs' PvP Talents' spells;
-- 2nd: GeneralTab;
-- 3rd: Other classes:
	-- 3.1. Each spec baseline spells;
	-- 3.2. Each spec Talents' spells;
	-- 3.3. Each spec PvP Talents' spells;
	-- 3.4. Flyouts (if there are spells for);
	-- 3.5. Pets (if there are spells for).

LibSN2SID.libLocal.setCurrentPetFirstInLookupOrder = function()
	local classKey = LibSN2SID.libLocal.playerUniversalClassName;
	if LibSN2SID.libLocal.LookupOrder_table[classKey].Pets then
		wipe(LibSN2SID.libLocal.LookupOrder_table[classKey].Pets);
	else
		local index = (LibSN2SID.DB[classKey].Flyouts and 5) or 4;
		tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], index, "Pets");
		LibSN2SID.libLocal.LookupOrder_table[classKey].Pets = {};
	end
	local petSpecName;
	if classKey == "HUNTER" then
		local petSpecIndex = (GetSpecialization(false, true));
		petSpecName = (petSpecIndex == 1 and "Ferocity") or (petSpecIndex == 2 and
			"Tenacity") or (petSpecIndex == 3 and "Cunning") or nil;
		-- print(tostring(petSpecIndex).. " : ".. tostring(petSpecName));
	end
	local petKey = (next(LibSN2SID.DB[classKey].Pets, nil));
	while petKey do
		if petSpecName and petKey == petSpecName then
			tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey].Pets, 1, petKey);
		elseif LibSN2SID.libLocal.petFamily and petKey == LibSN2SID.libLocal.petFamily then
			local index = (petSpecName and LibSN2SID.libLocal.LookupOrder_table[classKey].Pets[petSpecName] and 2) or 1;
			tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey].Pets, index, petKey);
		else
			tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey].Pets, petKey);
		end
		petKey = (next(LibSN2SID.DB[classKey].Pets, petKey));
	end
end
	
LibSN2SID.libLocal.SetLookupOrder = function()
	wipe(LibSN2SID.libLocal.LookupOrder_table); -- Reset the table
	local classOrderIndex = 1;
	-- local classKey = (next(LibSN2SID.DB, nil));
	local classKey = (next(LibSN2SID.DB.METADATA, nil));
	-- print(tostring(classKey));
	while classKey do
		if classKey == LibSN2SID.libLocal.playerUniversalClassName then	-- Current player class
			tinsert(LibSN2SID.libLocal.LookupOrder_table, 1, classKey);
			LibSN2SID.libLocal.LookupOrder_table[classKey] = {};
			-- print(tostring(LibSN2SID.libLocal.LookupOrder_table[1]));
			-- Order specs et al
			local playerActiveEnglishSpecName = (LibSN2SID.libLocal.GetActiveEnglishSpecialisationName());
			-- print("Active SpecName = ".. tostring(playerActiveEnglishSpecName));
			local specKey = (next(LibSN2SID.DB.METADATA[classKey].Specs, nil));
			while specKey do
				if specKey == playerActiveEnglishSpecName then
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], 1, specKey);
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], 2, specKey.."_Talents");
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], 3, specKey.."_PVPTalents");
					-- print(tostring(LibSN2SID.libLocal.LookupOrder_table[classKey][1]).. " *");
				-- elseif LibSN2SID.DB.METADATA[classKey].Specs[specKey] then
				else
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], specKey);
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], specKey.."_Talents");
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], specKey.."_PVPTalents");
				end
				specKey = (next(LibSN2SID.DB.METADATA[classKey].Specs, specKey));
			end
			if LibSN2SID.DB[classKey].Flyouts then
				tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], 4, "Flyouts");
				LibSN2SID.libLocal.LookupOrder_table[classKey].Flyouts = {};
				local flyoutButtonKey = (next(LibSN2SID.DB[classKey].Flyouts, nil));
				while flyoutButtonKey do
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey].Flyouts, flyoutButtonKey);
					flyoutButtonKey = (next(LibSN2SID.DB[classKey].Flyouts, flyoutButtonKey));
				end
			end
			if LibSN2SID.DB[classKey].Pets then
				LibSN2SID.libLocal.setCurrentPetFirstInLookupOrder();
			end
		elseif classKey ~= "General" then	-- Other classes
			tinsert(LibSN2SID.libLocal.LookupOrder_table, classKey);
			-- print(tostring(LibSN2SID.libLocal.LookupOrder_table[classOrderIndex]));
			LibSN2SID.libLocal.LookupOrder_table[classKey] = {};
			local specKey = (next(LibSN2SID.DB.METADATA[classKey].Specs, nil));
			while specKey do
				-- local numSpecSubTables = 3;	-- Unless we also have Flyouts, making it 4 or more
				tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], specKey);
				tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], specKey.."_Talents");
				tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], specKey.."_PVPTalents");
				specKey = (next(LibSN2SID.DB.METADATA[classKey].Specs, specKey));
			end
			if LibSN2SID.DB[classKey].Flyouts then
				tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], "Flyouts");
				LibSN2SID.libLocal.LookupOrder_table[classKey].Flyouts = {};
				local flyoutButtonKey = (next(LibSN2SID.DB[classKey].Flyouts, nil));
				while flyoutButtonKey do
					-- print(LibSpellName2SID_MAJOR.. ": ".. tostring(flyoutButtonKey));
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey].Flyouts, flyoutButtonKey);
					flyoutButtonKey = (next(LibSN2SID.DB[classKey].Flyouts, flyoutButtonKey));
				end
			end
			if LibSN2SID.DB[classKey].Pets then
				tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey], "Pets");
				LibSN2SID.libLocal.LookupOrder_table[classKey].Pets = {};
				local petKey = (next(LibSN2SID.DB[classKey].Pets, nil));
				while petKey do
					tinsert(LibSN2SID.libLocal.LookupOrder_table[classKey].Pets, petKey);
					petKey = (next(LibSN2SID.DB[classKey].Pets, petKey));
				end
			end
		end
		classKey = (next(LibSN2SID.DB.METADATA, classKey));
		classOrderIndex = classOrderIndex + 1;
	end
	tinsert(LibSN2SID.libLocal.LookupOrder_table, 2, "General");
	LibSN2SID.libLocal.LookupOrder_table["General"] = {};
	local categoryKey = (next(LibSN2SID.DB.General, nil));
	while categoryKey do
		if categoryKey == "Racials" then
			tinsert(LibSN2SID.libLocal.LookupOrder_table.General, "Racials");
			LibSN2SID.libLocal.LookupOrder_table.General.Racials = {};
			local racialKey = (next(LibSN2SID.DB.General.Racials, nil));
			while racialKey do
				if racialKey == LibSN2SID.libLocal.playerUniversalRaceName then
					tinsert(LibSN2SID.libLocal.LookupOrder_table.General.Racials, 1, racialKey);
				else
					tinsert(LibSN2SID.libLocal.LookupOrder_table.General.Racials, racialKey);
				end
				racialKey = (next(LibSN2SID.DB.General.Racials, racialKey));
			end
		-- elseif categoryKey ~= "METADATA" then	-- Currentlu not in the database
		else
			tinsert(LibSN2SID.libLocal.LookupOrder_table.General, categoryKey);
		end
		categoryKey = (next(LibSN2SID.DB.General, categoryKey));
	end
end


-- API --
---------

-- Return SpellID of the English Spell Name	--
LibSN2SID.libLocal.instanceSID = {};
-- LibSN2SID.libLocal.instanceSID.stub = { ["stub"] = 0 };
LibSN2SID.libLocal.instanceSID.metaT = {};
-- LibSN2SID.libLocal.instanceSID.metaT = LibSN2SID.DB or {};
LibSN2SID.libLocal.instanceSID.new = function(instObj)
	setmetatable(instObj, LibSN2SID.libLocal.instanceSID.metaT);
	return instObj;
end

LibSN2SID.libLocal.instanceSID.metaT.__index = function(tbl, engSpellName)	-- If spell name not found in 'tbl'.
	local paramType = type(engSpellName);
	-- print(LibSpellName2SID_MAJOR.. ": ".. engSpellName.. " is a ".. paramType);
	if (paramType == "string") then
		for classIndex = 1, #LibSN2SID.libLocal.LookupOrder_table do
			local classKey = LibSN2SID.libLocal.LookupOrder_table[classIndex];
			-- print(LibSpellName2SID_MAJOR.. ": ".. tostring(classKey));
			for specIndex = 1, #(LibSN2SID.libLocal.LookupOrder_table[classKey]) do
				local specKey = LibSN2SID.libLocal.LookupOrder_table[classKey][specIndex];
				-- Look in the instance's own faction-specific tables first, or SetFaction(...)
				--  would redund to doing nothing once SetDefaultFaction() has been run.
				if tbl and tbl.FactionSpells and tbl.FactionSpells[classKey] and tbl.FactionSpells[classKey][specKey] then
					-- print(LibSpellName2SID_MAJOR.. ": Looking for \'".. engSpellName.. "\' in client: ".. instanceName);
					local spID = tbl.FactionSpells[classKey][specKey][engSpellName] or nil;
					-- if spID then
					if type(spID) == "number" then
						return spID;	-- FOUND IT!
					end
			
					if LibSN2SID.libLocal.LookupOrder_table[classKey][specKey] ~= nil and type(LibSN2SID.libLocal.LookupOrder_table[classKey][specKey]) == "table" then
						local subTableKey = (next(tbl.FactionSpells[classKey][specKey], nil));
						while subTableKey do
							-- print(tostring(classKey).. " ".. tostring(specKey).. " ".. tostring(subTableKey));
							local spID = tbl.FactionSpells[classKey][specKey][subTableKey][engSpellName] or nil;
							-- if spID then
							if type(spID) == "number" then
								return spID;	-- FOUND IT!
							end
							subTableKey = (next(tbl.FactionSpells[classKey][specKey], subTableKey));
						end
					end
				end
				
				-- Lookup in the factions-shared table --
				local spID = LibSN2SID.DB[classKey][specKey][engSpellName] or nil;
				-- if spID then
				if type(spID) == "number" then
					return spID;	-- FOUND IT!
				end
				-- if specKey == "Flyouts" or specKey == "Pets" then
				if LibSN2SID.libLocal.LookupOrder_table[classKey][specKey] ~= nil and type(LibSN2SID.libLocal.LookupOrder_table[classKey][specKey]) == "table" then
					local subTableKey = (next(LibSN2SID.DB[classKey][specKey], nil));
					while subTableKey do
						-- print(tostring(classKey).. " ".. tostring(specKey).. " ".. tostring(subTableKey));
						local spID = LibSN2SID.DB[classKey][specKey][subTableKey][engSpellName] or nil;
						-- if spID then
						if type(spID) == "number" then
							return spID;	-- FOUND IT!
						end
						subTableKey = (next(LibSN2SID.DB[classKey][specKey], subTableKey));
					end
				end
			
			end
		end
		-- Didn't find the given spell name	in our database. So try and get it from game API
		local locSpellName, _, _, _, _, _, spID = GetSpellInfo(engSpellName);
		return spID;
	elseif (paramType == "number") then
		local locSpellName = (GetSpellInfo(engSpellName));
		-- print(tostring(locSpellName));
		if locSpellName then
			return engSpellName;
		else
			return nil;
		end
	else
		-- TODO: error() ?
		return nil;
	end
end

-- Return Localised Name of the English Spell Name	--
LibSN2SID.libLocal.instanceLSN = {};
-- LibSN2SID.libLocal.instanceLSN.stub = { ["stub"] = 0 };
LibSN2SID.libLocal.instanceLSN.metaT = {};
-- LibSN2SID.libLocal.instanceLSN.metaT = LibSN2SID.DB or {};
LibSN2SID.libLocal.instanceLSN.new = function(instObj)
	setmetatable(instObj, LibSN2SID.libLocal.instanceLSN.metaT);
	return instObj;
end
LibSN2SID.libLocal.instanceLSN.metaT.__index = function(tbl, engSpellName)
	-- print("LSN __index");
	local paramType = type(engSpellName);
	-- print(LibSpellName2SID_MAJOR.. ": ".. engSpellName.. " is a ".. paramType);
	if paramType == "string" then
		for classIndex = 1, #LibSN2SID.libLocal.LookupOrder_table do
			local classKey = LibSN2SID.libLocal.LookupOrder_table[classIndex];
			-- print(LibSpellName2SID_MAJOR.. ": ".. tostring(classKey));
			for specIndex = 1, #(LibSN2SID.libLocal.LookupOrder_table[classKey]) do
				-- print(LibSpellName2SID_MAJOR.. ": ".. tostring(specKey));
				local specKey = LibSN2SID.libLocal.LookupOrder_table[classKey][specIndex];
				
				-- Look in the instance's own faction-specific tables first, or SetFaction(...)
				--  would redund to doing nothing once SetDefaultFaction() has been run.
				if tbl and tbl.FactionSpells and tbl.FactionSpells[classKey] and tbl.FactionSpells[classKey][specKey] then
					-- print(LibSpellName2SID_MAJOR.. ": Looking for \'".. engSpellName.. "\' in client: ".. instanceName);
					local spID = tbl.FactionSpells[classKey][specKey][engSpellName] or nil;
					if spID then
						local locSpellName = (GetSpellInfo(spID)); -- Localised spell name
						return locSpellName;	-- FOUND IT!
					end

					if LibSN2SID.libLocal.LookupOrder_table[classKey][specKey] ~= nil and type(LibSN2SID.libLocal.LookupOrder_table[classKey][specKey]) == "table" then
						local subTableKey = (next(tbl.FactionSpells[classKey][specKey], nil));
						while subTableKey do
							-- print(tostring(classKey).. " ".. tostring(specKey).. " ".. tostring(subTableKey));
							local spID = tbl.FactionSpells[classKey][specKey][subTableKey][engSpellName] or nil;
							if spID then
							   local locSpellName = (GetSpellInfo(spID)); -- Localised spell name
								return locSpellName;	-- FOUND IT!
							end
							subTableKey = (next(tbl.FactionSpells[classKey][specKey], subTableKey));
						end
					end
				end
				
				-- Lookup in the factions-shared table --
				local spID = LibSN2SID.DB[classKey][specKey][engSpellName] or nil;
				if spID then
					-- print("Found in ".. classKey.. ": ".. specKey);
					local locSpellName = (GetSpellInfo(spID)); -- Localised spell name
					return locSpellName;	-- FOUND IT!
				end
				if LibSN2SID.libLocal.LookupOrder_table[classKey][specKey] ~= nil and type(LibSN2SID.libLocal.LookupOrder_table[classKey][specKey]) == "table" then
					local subTableKey = (next(LibSN2SID.DB[classKey][specKey], nil));
					while subTableKey do
						-- print(tostring(classKey).. " ".. tostring(specKey).. " ".. tostring(subTableKey));
						local spID = LibSN2SID.DB[classKey][specKey][subTableKey][engSpellName] or nil;
						if spID then
                           local locSpellName = (GetSpellInfo(spID)); -- Localised spell name
							return locSpellName;	-- FOUND IT!
						end
						subTableKey = (next(LibSN2SID.DB[classKey][specKey], subTableKey));
					end
				end
				
			end
		end
		-- Didn't find the given spell name in our database. So try and get it from game API
		local locSpellName, _, _, _, _, _, spID = GetSpellInfo(engSpellName);
		return locSpellName;
	elseif paramType == "number" then
				local locSpellName = (GetSpellInfo(engSpellName));
				-- print(locSpellName);
				return locSpellName;
	else
		-- TODO: error() ?
		return nil;
	end
end


-- Blizzard events used by the library --
-----------------------------------------

LibSN2SID.libFrame:RegisterEvent("PLAYER_LOGIN");
LibSN2SID.libLocal.lookupOrderTableInitialized = false;
LibSN2SID.libFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");	-- This talent and/or the one in the line bellow
LibSN2SID.libFrame:RegisterEvent("PLAYER_TALENT_UPDATE");			--  should fire when the player switches spec.
LibSN2SID.libFrame:RegisterUnitEvent("UNIT_PET", "player");	-- Fired when a unit's pet changes.
LibSN2SID.libFrame:RegisterEvent("PET_SPECIALIZATION_CHANGED");	-- Fired upon pet's specialisation changes.
LibSN2SID.libFrame:SetScript("OnEvent", function(self, event)
	if event == "PLAYER_LOGIN" or event == "PLAYER_ENTERING_WORLD" then
		local stubVal;
		stubVal, LibSN2SID.libLocal.playerUniversalClassName = UnitClass("player");
		stubVal, LibSN2SID.libLocal.playerUniversalRaceName = UnitRace("player");
		LibSN2SID.libLocal.SetDefaultFaction(instanceName);
		if UnitExists("pet") then	-- Get current Pet data to build the corresponding lookup table
			LibSN2SID.libLocal.petFamily = UnitCreatureFamily("pet");
		end
		LibSN2SID.libLocal.SetLookupOrder();
		LibSN2SID.libLocal.lookupOrderTableInitialized = true;
	elseif LibSN2SID.libLocal.lookupOrderTableInitialized then
		if event == "UNIT_PET" or event == "PET_SPECIALIZATION_CHANGED" then
			if not LibSN2SID.libLocal.playerUniversalClassName or not LibSN2SID.libLocal.LookupOrder_table[LibSN2SID.libLocal.playerUniversalClassName] then
				return;	-- Build lookup table for Pet only after we built the lookup table for Class
			end
			LibSN2SID.libLocal.petFamily = UnitCreatureFamily("pet");
			if not LibSN2SID.libLocal.petFamily then	-- UNIT_PET fires several times when a pet
				return;				--  is lost and when a new one is called; we'll get the new pet
			end						--  info eventually, but we'll wait til it's up.
			LibSN2SID.libLocal.setCurrentPetFirstInLookupOrder();
		else
			LibSN2SID.libLocal.SetLookupOrder();
		end
	end
	-- -- Print the resulting lookup order
	-- for i = 1, #LibSN2SID.libLocal.LookupOrder_table do
		-- local classKey = LibSN2SID.libLocal.LookupOrder_table[i];
		-- print(LibSpellName2SID_MAJOR.. ": ".. i.. ". ".. tostring(classKey));
		-- for ii = 1, #(LibSN2SID.libLocal.LookupOrder_table[classKey]) do
			-- local specKey = LibSN2SID.libLocal.LookupOrder_table[classKey][ii];
			-- print(LibSpellName2SID_MAJOR.. ": ".. i.. ".".. ii.. ". ".. tostring(specKey));
			-- if type(LibSN2SID.libLocal.LookupOrder_table[classKey][specKey]) == "table" then
				-- for iii = 1, #(LibSN2SID.libLocal.LookupOrder_table[classKey][specKey]) do
					-- local subTableKey = LibSN2SID.libLocal.LookupOrder_table[classKey][specKey][iii];
					-- print(LibSpellName2SID_MAJOR.. ": ".. i.. ".".. ii.. ".".. iii.. ". ".. tostring(subTableKey));
				-- end
			-- end
		-- end
	-- end
end);


-- Library Instances Registration and Removal --
------------------------------------------------

-- Register a new instance of this library
function LibSN2SID:NewInstance(instanceName)
	-- print(LibSpellName2SID_MAJOR.. ": Just started function LibSN2SID:NewInstance(".. instanceName.. ")");
	if (type(instanceName) ~= "string") or (instanceName == "") then
		error("Must provide a valid instanceName (unique string) to the new library instance of ".. LibSpellName2SID_MAJOR.. ".");
	elseif instanceName == LibSpellName2SID_MAJOR then
		error("Cannot create a new instance of ".. LibSpellName2SID_MAJOR.. "with the name".. LibSpellName2SID_MAJOR.. " (that name is reserved).");
	elseif LibSN2SID.clients and LibSN2SID.clients[instanceName] then
		error("Will not create a duplicate instance of ".. LibSpellName2SID_MAJOR.. ", with the already existing name: ".. instanceName.. ".");
	end
	
	LibSN2SID.clients = LibSN2SID.clients or {};
	LibSN2SID.clients[instanceName] = {};
	LibSN2SID.clients[instanceName].SID = LibSN2SID.clients[instanceName].SID or {};
	LibSN2SID.clients[instanceName].LSN = LibSN2SID.clients[instanceName].LSN or {};

	-- LibSN2SID.clients[instanceName].SID = LibSN2SID.libLocal.instanceSID.new(LibSN2SID.clients[instanceName].SID);
	-- LibSN2SID.clients[instanceName].LSN = LibSN2SID.libLocal.instanceLSN.new(LibSN2SID.clients[instanceName].LSN);
	LibSN2SID.clients[instanceName].SID = LibSN2SID.libLocal.instanceSID:new(LibSN2SID.clients[instanceName].SID);
	LibSN2SID.clients[instanceName].LSN = LibSN2SID.libLocal.instanceLSN:new(LibSN2SID.clients[instanceName].LSN);
	return LibSN2SID;
end

-- Remove an instance of this library, if the data isn't needed anymore
function LibSN2SID:RemoveInstance(instanceName, ...)
	-- print(LibSpellName2SID_MAJOR.. ": RemoveInstance: ".. tostring(instanceName));
	local DontErrorOnInexistentInstanceName = ... or false;
	
	if (type(instanceName) ~= "string") or (instanceName == "") then
		error("Must provide a valid instanceName (string) of the ".. LibSpellName2SID_MAJOR.. " library, to cleanup.");
	elseif instanceName == LibSpellName2SID_MAJOR then
		error("Will not remove base-instance \"".. instanceName.. "\" of library ".. LibSpellName2SID_MAJOR.. ".");
	elseif (not LibSN2SID.clients) or (not LibSN2SID.clients[instanceName]) then
		if DontErrorOnInexistentInstanceName then
			return false;
		else
			error("Cannot clean up instance of ".. LibSpellName2SID_MAJOR.. ", with name: ".. instanceName.. " (non existent).");
		end
	end
	
	LibSN2SID.clients[instanceName] = nil;
	return LibSN2SID.clients[instanceName];
end


-- Get the number of spells in the database
-- TODO: Redo for new DB structure in 10008+ !
-- function LibSN2SID:GetNumSpells()
	-- error("This function is not implemented in the current versions of ".. LibSpellName2SID_MAJOR.. ": ".. LibAlkaTest_MINOR);
	-- local count = 0;
	-- for _ in pairs(LibSN2SID.DB) do
		-- count = count + 1;
	-- end
	-- return count;
-- end


------------------------------------------
-- print(LibSpellName2SID_MAJOR.. ": LibSN2SID.DB has ".. LibSN2SID.GetNumSpells().. " keys.");
