---------------------------
-- LibSpellName2SID - test1
-- Test some base spells
---------------------------

local AddonName, AddonEnv = ...;
local testsSharedName = AddonName.."-Tests";

local LIBSN2SID = AddonEnv.LIBSN2SID or LibStub("LibSpellName2SID-1.1"):NewInstance(testsSharedName);
local SID = LIBSN2SID.clients[testsSharedName].SID;
local LSN = LIBSN2SID.clients[testsSharedName].LSN;
-- local SID = LIBSN2SID.SID;
-- local LSN = LIBSN2SID.LSN;

local Frame = CreateFrame("Frame");
Frame:RegisterEvent("PLAYER_LOGIN");	-- Not enough data from game til this event fires.
-- Frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");	-- This talent and/or the one in the line bellow
-- Frame:RegisterEvent("PLAYER_TALENT_UPDATE");		--  should fire when the player switches spec.
													-- TESTED: Both of these fire Twice on Changing
													--  spec. On Login but "ACTIVE_..." fires Once, 
													--  but "PLAYER_TALENT_..." fires Twice.
-- Frame:RegisterEvent("PLAYER_ENTERING_WORLD");
													
Frame:SetScript("OnEvent", function()
	C_Timer.After(3, function()
		print(testsSharedName.. ": Starting test1 - some base spells.");
		if SID and LSN then
			local startTime = GetTime();
			print(testsSharedName.. tostring(": SID and LSN found."));
			local endTime = GetTime();
			print("print time with tostring(...) = ".. (endTime - startTime).. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": SID[\"Auto Attack\"] = ".. tostring(SID["Auto Attack"])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": LSN[\"Auto Attack\"] = ".. tostring(LSN["Auto Attack"])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": SID[\"Made It Up\"] = ".. tostring(SID["Made It Up"])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": LSN[\"Made It Up\"] = ".. tostring(LSN["Made It Up"])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");

			startTime = GetTime();
			print(testsSharedName.. ": SID[210873] = ".. tostring(SID[210873])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": LSN[210873] = ".. tostring(LSN[210873])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": SID[6603] = ".. tostring(SID[6603]));
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": LSN[6603] = ".. tostring(LSN[6603]));
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": SID[\"Lightning Bolt\"] = ".. tostring(SID["Lightning Bolt"])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": LSN[\"Lightning Bolt\"] = ".. tostring(LSN["Lightning Bolt"])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": SID[\"Taunt\"] = ".. tostring(SID["Taunt"])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
			
			startTime = GetTime();
			print(testsSharedName.. ": LSN[\"Taunt\"] = ".. tostring(LSN["Taunt"])); -- 
			endTime = GetTime();
			print(testsSharedName.. "... in ".. endTime - startTime.. "ns.");
        else
			print(testsSharedName.. ": SID and/or LSN not found.");
		end
	end);
end);

-- Export to addon's environment:
AddonEnv.LIBSN2SID = LIBSN2SID;