--------------------------------------------------------
-- LibSpellName2SID - test3
-- Test Alliance/Horde spells (same name, different IDs)
--------------------------------------------------------

local AddonName, AddonEnv = ...;
local testsSharedName = AddonName.."-Tests";

local LIBSN2SID = AddonEnv.LIBSN2SID or LibStub("LibSpellName2SID-1.1"):NewInstance(testsSharedName);
local SID = LIBSN2SID.clients[testsSharedName].SID;
local LSN = LIBSN2SID.clients[testsSharedName].LSN;
-- local SID = LIBSN2SID.SID;
-- local LSN = LIBSN2SID.LSN;

local Frame = CreateFrame("Frame");
Frame:RegisterEvent("PLAYER_LOGIN");	-- Not enough data from game til this event fires.
-- Frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");	-- This talent and/or the one in the line bellow
-- Frame:RegisterEvent("PLAYER_TALENT_UPDATE");		--  should fire when the player switches spec.
													-- TESTED: Both of these fire Twice on Changing
													--  spec. On Login but "ACTIVE_..." fires Once, 
													--  but "PLAYER_TALENT_..." fires Twice.
-- Frame:RegisterEvent("PLAYER_ENTERING_WORLD");
													
Frame:SetScript("OnEvent", function()
	C_Timer.After(5, function()
		print(testsSharedName.. ": Starting test3 - Alliance/Horde spells (same name, different IDs).");
		if SID and LSN then
			local playerFaction = UnitFactionGroup("player");
		
			print(testsSharedName.. ": LSN[\"Portal: Tol Barad(Alliance)\"] = ".. tostring(LSN["Portal: Tol Barad(Alliance)"])); -- 
			print(testsSharedName.. ": LSN[\"Portal: Tol Barad(Horde)\"] = ".. tostring(LSN["Portal: Tol Barad(Horde)"])); -- 
			print(testsSharedName.. ": LSN[\"Portal: Tol Barad\"] = ".. tostring(LSN["Portal: Tol Barad"])); -- 
			print(testsSharedName.. ": SID[\"Portal: Tol Barad(Alliance)\"] = ".. tostring(SID["Portal: Tol Barad(Alliance)"])); -- 
			print(testsSharedName.. ": SID[\"Portal: Tol Barad(Horde)\"] = ".. tostring(SID["Portal: Tol Barad(Horde)"])); -- 
			print(testsSharedName.. ": SID[\"Portal: Tol Barad\"] = ".. tostring(SID["Portal: Tol Barad"])); -- 

			
			print(testsSharedName.. ": Will now set faction to Alliance.");
			LIBSN2SID.SetFaction("Alliance", testsSharedName);
			print(testsSharedName.. ": LSN[\"Portal: Tol Barad\"] = ".. tostring(LSN["Portal: Tol Barad"]));
			print(testsSharedName.. ": SID[\"Portal: Tol Barad\"] = ".. tostring(SID["Portal: Tol Barad"]));
			
			-- Lib 1.1.09 extra test: Test if we can access "Portal: Shattrath" directly from the DB
			print(testsSharedName.. ": Mid-mainchunk-test: Directly from DB: LIBSN2SID.DB.MAGE.Flyouts.Portal[\"Portal: Tol Barad\"] = ".. tostring(LIBSN2SID.DB.MAGE.Flyouts.Portal["Portal: Tol Barad"]));
			print(testsSharedName.. ": Verify the above via: (SID[\"Portal: Tol Barad\"] == LIBSN2SID.DB.MAGE.Flyouts.Portal[\"Portal: Tol Barad\"])? ".. tostring(SID["Portal: Tol Barad"] == LIBSN2SID.DB.MAGE.Flyouts.Portal["Portal: Tol Barad"]));

			
			print(testsSharedName.. ": Will now set faction to Horde.");
			LIBSN2SID.SetFaction("Horde", testsSharedName);
			print(testsSharedName.. ": LSN[\"Portal: Tol Barad\"] = ".. tostring(LSN["Portal: Tol Barad"]));
			print(testsSharedName.. ": SID[\"Portal: Tol Barad\"] = ".. tostring(SID["Portal: Tol Barad"]));
			
			-- Lib 1.1.09 extra test: Test if we can access "Portal: Shattrath" directly from the DB
			print(testsSharedName.. ": Mid-mainchunk-test: Directly from DB: LIBSN2SID.DB.MAGE.Flyouts.Portal[\"Portal: Tol Barad\"] = ".. tostring(LIBSN2SID.DB.MAGE.Flyouts.Portal["Portal: Tol Barad"]));
			print(testsSharedName.. ": Verify the above via: (SID[\"Portal: Tol Barad\"] == LIBSN2SID.DB.MAGE.Flyouts.Portal[\"Portal: Tol Barad\"])? ".. tostring(SID["Portal: Tol Barad"] == LIBSN2SID.DB.MAGE.Flyouts.Portal["Portal: Tol Barad"]));

			
			print(testsSharedName.. ": Will now set faction to player\'s.");
			LIBSN2SID.SetFaction(playerFaction, testsSharedName);
			print(testsSharedName.. ": LSN[\"Portal: Tol Barad\"] = ".. tostring(LSN["Portal: Tol Barad"]));
			print(testsSharedName.. ": SID[\"Portal: Tol Barad\"] = ".. tostring(SID["Portal: Tol Barad"]));
			
			-- Lib 1.1.09 extra test: Test if we can access "Portal: Shattrath" directly from the DB
			print(testsSharedName.. ": Post-mainchunk-test: Directly from DB: LIBSN2SID.DB.MAGE.Flyouts.Portal[\"Portal: Tol Barad\"] = ".. tostring(LIBSN2SID.DB.MAGE.Flyouts.Portal["Portal: Tol Barad"]));
			print(testsSharedName.. ": Verify the above via: (SID[\"Portal: Tol Barad\"] == LIBSN2SID.DB.MAGE.Flyouts.Portal[\"Portal: Tol Barad\"])? ".. tostring(SID["Portal: Tol Barad"] == LIBSN2SID.DB.MAGE.Flyouts.Portal["Portal: Tol Barad"]));

        else
			print(testsSharedName.. ": SID and/or LSN not found.");
		end
	end);
end);

-- Export to addon's environment:
AddonEnv.LIBSN2SID = LIBSN2SID;