--------------------------------------------------------
-- LibSpellName2SID - test4
-- Test Removal and re-Registration of library instances
--------------------------------------------------------

local AddonName, AddonEnv = ...;
local testsSharedName = AddonName.."-Tests";

local LIBSN2SID = AddonEnv.LIBSN2SID or LibStub("LibSpellName2SID-1.1"):NewInstance(testsSharedName);
local SID = LIBSN2SID.clients[testsSharedName].SID;
local LSN = LIBSN2SID.clients[testsSharedName].LSN;
-- local SID = LIBSN2SID.SID;
-- local LSN = LIBSN2SID.LSN;

local Frame = CreateFrame("Frame");
Frame:RegisterEvent("PLAYER_LOGIN");	-- Not enough data from game til this event fires.
-- Frame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");	-- This talent and/or the one in the line bellow
-- Frame:RegisterEvent("PLAYER_TALENT_UPDATE");		--  should fire when the player switches spec.
							-- TESTED: Both of these fire Twice on Changing
							--  spec. But On Login "ACTIVE_..." fires Once, 
							--  whereas "PLAYER_TALENT_..." fires Twice.
-- Frame:RegisterEvent("PLAYER_ENTERING_WORLD");
													
Frame:SetScript("OnEvent", function()
	C_Timer.After(5, function()
		print(testsSharedName.. ": Starting test4 - Removal and re-Registration of library instances.");
		if SID and LSN then
			print(testsSharedName.. ": LSN[\"Portal: Shattrath(Alliance)\"] = ".. tostring(LSN["Portal: Shattrath(Alliance)"])); -- 
			print(testsSharedName.. ": LSN[\"Portal: Shattrath(Horde)\"] = ".. tostring(LSN["Portal: Shattrath(Horde)"])); -- 
			print(testsSharedName.. ": LSN[\"Portal: Shattrath\"] = ".. tostring(LSN["Portal: Shattrath"])); -- 
			print(testsSharedName.. ": SID[\"Portal: Shattrath(Alliance)\"] = ".. tostring(SID["Portal: Shattrath(Alliance)"])); -- 
			print(testsSharedName.. ": SID[\"Portal: Shattrath(Horde)\"] = ".. tostring(SID["Portal: Shattrath(Horde)"])); -- 
			print(testsSharedName.. ": SID[\"Portal: Shattrath\"] = ".. tostring(SID["Portal: Shattrath"])); -- 
			
			print(testsSharedName.. ": type(LIBSN2SID) = ".. type(LIBSN2SID));
			print(testsSharedName.. ": type(LIBSN2SID.clients) = ".. type(LIBSN2SID.clients));
			print(testsSharedName.. ": type(LIBSN2SID.clients[".. testsSharedName.. "]) = ".. type(LIBSN2SID.clients[testsSharedName]));
			if type(LIBSN2SID) == "table" then
				-- local tableKey = next(LIBSN2SID, nil);
				-- local tableValue;
				-- while tableKey do 
					-- tableValue = tostring(LIBSN2SID[tableKey]);
					-- print(testsSharedName.. ": Key = ".. tableKey.. " Value = ".. tableValue);
					-- tableKey = next(LIBSN2SID, tableKey);
				-- end
				-- tableKey, tableValue = nil, nil;
				-- print(testsSharedName.. ": No more values to print.");
				if LIBSN2SID.clients[testsSharedName] then
					local tableKey = next(LIBSN2SID.clients[testsSharedName], nil);
					local tableValue;
					while tableKey do 
						tableValue = tostring(LIBSN2SID.clients[testsSharedName][tableKey]);
						print(testsSharedName.. ": Key = ".. tableKey.. " Value = ".. tableValue);
						tableKey = next(LIBSN2SID.clients[testsSharedName], tableKey);
					end
					tableKey, tableValue = nil, nil;
					print(testsSharedName.. ": No more values to print.");
				end
			end
			print(testsSharedName.. ": Will now remove this instance of LibSpellName2SID-1.1 !");
			LIBSN2SID:RemoveInstance(testsSharedName);
			print(testsSharedName.. ": type(LIBSN2SID) = ".. type(LIBSN2SID));
			print(testsSharedName.. ": type(LIBSN2SID.clients) = ".. type(LIBSN2SID.clients));
			print(testsSharedName.. ": type(LIBSN2SID.clients[".. testsSharedName.. "]) = ".. type(LIBSN2SID.clients[testsSharedName]));
			if type(LIBSN2SID) == "table" then
				-- local tableKey = next(LIBSN2SID, nil);
				-- local tableValue;
				-- while tableKey do 
					-- tableValue = tostring(LIBSN2SID[tableKey]);
					-- print(testsSharedName.. ": Key = ".. tableKey.. " Value = ".. tableValue);
					-- tableKey = next(LIBSN2SID, tableKey);
				-- end
				-- tableKey, tableValue = nil, nil;
				-- print(testsSharedName.. ": No more values to print.");
				if LIBSN2SID.clients[testsSharedName] then
					local tableKey = next(LIBSN2SID.clients[testsSharedName], nil);
					local tableValue;
					while tableKey do 
						tableValue = tostring(LIBSN2SID.clients[testsSharedName][tableKey]);
						print(testsSharedName.. ": Key = ".. tableKey.. " Value = ".. tableValue);
						tableKey = next(LIBSN2SID.clients[testsSharedName], tableKey);
					end
					tableKey, tableValue = nil, nil;
					print(testsSharedName.. ": No more values to print.");
				end
			end
			print(testsSharedName.. ": Will now register a new instance of LibSpellName2SID-1.1 as \"".. testsSharedName.. "\"!");
			LIBSN2SID = LibStub("LibSpellName2SID-1.1"):NewInstance(testsSharedName);
			
			print(testsSharedName.. ": SID[\"Auto Attack\"] = ".. tostring(SID["Auto Attack"]));
			print(testsSharedName.. ": LSN[\"Auto Attack\"] = ".. tostring(LSN["Auto Attack"]));
			print(testsSharedName.. ": SID[\"Made It Up\"] = ".. tostring(SID["Made It Up"]));
			print(testsSharedName.. ": LSN[\"Made It Up\"] = ".. tostring(LSN["Made It Up"]));
			print(testsSharedName.. ": SID[\"Hex(Spider)\"] = ".. tostring(SID["Hex(Spider)"]));
			print(testsSharedName.. ": LSN[\"Hex(Spider)\"] = ".. tostring(LSN["Hex(Spider)"]));
			print(testsSharedName.. ": LSN[\"Portal: Shattrath\"] = ".. tostring(LSN["Portal: Shattrath"]));
			print(testsSharedName.. ": SID[\"Portal: Shattrath\"] = ".. tostring(SID["Portal: Shattrath"]));
			        else
			print(testsSharedName.. ": SID and/or LSN not found.");
		end
	end);
end);

-- Export to addon's environment:
AddonEnv.LIBSN2SID = LIBSN2SID;
